# Release Notes for STM32F2xx HAL Drivers

Copyright © 2017 STMicroelectronics

# License

This software component is licensed by ST under BSD 3-Clause license, the “License”; You may not use this component except in compliance with the License. You may obtain a copy of the License at:
https://opensource.org/licenses/BSD-3-Clause

# Update History

V1.2.6 / 22-October-2020

## Main Changes

- General updates to fix known defects.

## Contents

- HAL/LL I2C driver
  - Update to fix hardfault issue with HAL_I2C_Mem_Write_DMA() API:
    - Abort the right ongoing DMA transfer when memory write access request operation failed: fix typo “hdmarx” replaced by “hdmatx”

V1.2.5 / 09-September-2020

## Main Changes

- General updates to fix known defects and enhancements implementation.
- HAL driver
  - Enhance HAL_SetTickFreq() API robustness:
    - HAL_SetTickFreq(): update to restore the previous tick frequency when HAL_InitTick() configuration failed.
  - Add new defines for ARM compiler V6:
    - __weak
    - __packed
    - __NOINLINE
  - Update HAL_Init_Tick() API to proporely store the priority when using the non-default time base.
- HAL/LL ADC driver
  - Update the type for the following ADC parameters in ADC_InitTypeDef structure to fix MISRA-C 2012 Rule-10.4 error
    - uint32_t ContinuousConvMode to FunctionalState ContinuousConvMode
    - uint32_t DiscontinuousConvMode to FunctionalState DiscontinuousConvMode
    - uint32_t DMAContinuousRequests to FunctionalState DMAContinuousRequests
  - Update the following APIs to set status HAL_ADC_STATE_ERROR_INTERNAL and error code HAL_ADC_ERROR_INTERNAL when error occurs:
    - HAL_ADC_Start()
    - HAL_ADC_Start_IT()
    - HAL_ADC_Start_DMA()
    - HAL_ADCEx_InjectedStart()
    - HAL_ADCEx_InjectedStart_IT()
    - HAL_ADCEx_MultiModeStart_DMA()
  - Update HAL_ADC_Stop_DMA() API to check if DMA state is Busy before calling HAL_DMA_Abort() API to avoid DMA internal error.
  - Update LL_ADC_REG_Init() API to avoid enabling continuous mode and discontinuous mode simultaneously.
- HAL/LL GPIO driver
  - Update HAL_GPIO_TogglePin() API to allow multi Pin’s toggling.
  - Update LL_GPIO_TogglePin() API to improve robustness: use BSRR register instead of ODR register.
- HAL/LL RCC driver
  - Add new HAL interfaces allowing to control the activation or deactivation of PLLI2S:
    - HAL_RCCEx_EnablePLLI2S()
    - HAL_RCCEx_DisablePLLI2S()
  - Add new HAL macros
    - __HAL_RCC_GET_RTC_SOURCE()allowing to get the RTC clock source
    - __HAL_RCC_GET_RTC_HSE_PRESCALER()allowing to get the HSE clock divider for RTC peripheral.
  - Update HAL_RCC_OscConfig() API to avoid overwriting a reserved bit
    - Update to use MODIFY_REG instead of WRITE_REG.
- HAL/LL HASH driver
  - Fix Misra-C 2012 Rule-5.1 warning on identifiers to be distinct in the first 31 characters in renaming all HAL_HASH_xxx_Accumulate_yy() and HAL_HASHEx_xxx_Accumulate_yy() APIs respectively into HAL_HASH_xxx_Accmlt_yy() and HAL_HASHEx_xxx_Accmlt_yy()
  - Correct phase management issue when performing two successive hash operations on two different buffers
  - Create new APIs to initialize the HASH peripheral then processes pInBuffer in interruption mode.
    - HASH_Accumulate_IT()
    - HAL_HASH_SHA1_Accmlt_IT()
    - HAL_HASH_MD5_Accmlt_IT()
  - Create new APIs to wrap-up multi-buffer hashing processing in polling and interrupt modes
    - HAL_HASH_MD5_Accmlt_End()
    - HAL_HASH_SHA1_Accmlt_End()
    - HAL_HASH_MD5_Accmlt_End_IT()
    - HAL_HASH_SHA1_Accmlt_End_IT()
  - Ensure processing suspension flag is reset to HAL_HASH_SUSPEND_NONE value in HAL_HASH_Init() API
  - Add comments to describe case of message made of several parts, not all with length multiple of 4 bytes.
  - HASH_DMAXferCplt() callback API state improperly set to READY instead of BUSY fixed.
- HAL NOR driver
  - Correct MISRA-C 2012-Rule-10.4_a / 14.4_d / 18.4 warnings in HAL NOR drivers
  - Update address calculation in HAL_NOR_ProgramBuffer()
  - Add new commands operations:
    - NOR_CMD_READ_ARRAY
    - NOR_CMD_WORD_PROGRAM
    - NOR_CMD_BUFFERED_PROGRAM
    - NOR_CMD_CONFIRM
    - NOR_CMD_BLOCK_ERASE
    - NOR_CMD_BLOCK_UNLOCK
    - NOR_CMD_READ_STATUS_REG
    - NOR_CMD_CLEAR_STATUS_REG
  - Apply adequate commands according to the command set field value
    - command set 1 for Micron JS28F512P33
    - command set 2 for Micron M29W128G and Cypress S29GL128P
  - Update some APIs in order to be compliant for memories with another command set.
    - HAL_NOR_Init()
    - HAL_NOR_Read_ID()
    - HAL_NOR_ReturnToReadMode()
    - HAL_NOR_Read()
    - HAL_NOR_Program()
    - HAL_NOR_ReadBuffer()
    - HAL_NOR_ProgramBuffer()
    - HAL_NOR_Erase_Block()
    - HAL_NOR_Erase_Chip()
    - HAL_NOR_GetStatus()
- HAL SRAM driver
  - General update to enhance HAL SRAM driver robustness
    - Update HAL_SRAM_Init() API to avoid activation of burst access for SRAM
- LL FSMC driver
  - Remove useless casts.
  - Update FSMC_NORSRAM_Init() API in order to resolve compilation issue with Microsoft Visual Studio 2017.
  - Update FSMC_NORSRAM_Extended_Timing_Init() API in order to manage Bus turnaround phase duration FSMC_BWTR1_BUSTURN availability.
- HAL/LL IWDG driver
  - Update HAL_IWDG_DEFAULT_TIMEOUT define value to consider LSI value instead of hardcoded value
- HAL/LL I2C update
  - Update I2C_MasterReceiveRXNE() static API to avoid set the STOP bit again after the bit clearing by Hardware during the masking operation
    - Add new API I2C_WaitOnSTOPRequestThroughIT() to wait for stop bit.
  - Update sequential APIs to avoid requesting a START when a STOP condition is not fully treated
    - Wait the end of STOP treatment by polling (with a timeout) the STOP bit on Control register CR1
  - Update HAL_I2C_ER_IRQHandler() API to fix acknowledge failure issue with I2C memory IT processes
    - Add stop condition generation when NACK occurs.
- HAL/LL I2S driver
  - Update HAL_I2S_DMAStop() API to be more safe
    - Add a check on BSY, TXE and RXNE flags before disabling the I2S
  - Update HAL_I2S_DMAStop() API to fix multi-call transfer issue(to avoid re-initializing the I2S for the next transfer).
    - Add __HAL_I2SEXT_FLUSH_RX_DR() and __HAL_I2S_FLUSH_RX_DR() macros to flush the remaining data inside DR registers.
    - Add new ErrorCode define: HAL_I2S_ERROR_BUSY_LINE_RX
- HAL/LL SPI driver
  - Update SPI_DMAReceiveCplt() API to handle efficiently the repeated transfers.
    - Disable TX DMA request only in bidirectional receive mode
  - Update HAL_SPI_Init() API
    - To avoid setting the BaudRatePrescaler in case of Slave Motorola Mode
    - Use the bit-mask for SPI configuration
  - Update Transmit/Receive processes in half-duplex mode
    - Disable the SPI instance before setting BDIOE bit
  - Fix wrong timeout management
    - Calculate Timeout based on a software loop to avoid blocking issue if Systick is disabled
- HAL/LL UART driver
  - Update UART BRR calculation for ROM size gain
  - Update UART polling and interruption processes to fix issues related to accesses out of user specified buffer.
    - Update UART_Transmit_IT(), UART_Receive_IT(), HAL_UART_Transmit() and HAL_UART_Receive() APIs.
- HAL SMARTCARD driver
  - Update SMARTCARD transmission and reception APIs to handle memory corruption
    - HAL_SMARTCARD_Transmit(), HAL_SMARTCARD_Receive(), HAL_SMARTCARD_Transmit_IT() and HAL_SMARTCARD_Receive_IT()
- HAL/LL TIM driver
  - Align HAL/LL TIM driver with latest updates and enhancements
  - Update Encoder interface mode to keep TIM_CCER_CCxNP bits low
    - Add TIM_ENCODERINPUTPOLARITY_RISING and TIM_ENCODERINPUTPOLARITY_FALLING definitions to determine encoder input polarity.
    - Add IS_TIM_ENCODERINPUT_POLARITY() macro to check the encoder input polarity.
    - Update HAL_TIM_Encoder_Init() API
    - Replace IS_TIM_IC_POLARITY() macro by IS_TIM_ENCODERINPUT_POLARITY() macro.
  - Fix bug when using multiple DMA request to different channels of same timer
    - Introduce DMA burst state management mechanism
      - Add a new structure for DMA Burst States definition : HAL_TIM_DMABurstStateTypeDef
      - Update __HAL_TIM_RESET_HANDLE_STATE to support DMABurstState
      - Add a new API HAL_TIM_DMABurstState() to get the actual state of a DMA burst operation
      - Add DMABurstState, the DMA burst operation state, in the TIM_HandleTypeDef structure
      - Add new API TIM_DMAErrorCCxN() for TIM DMA error callback (complementary channel)
      - Add new API TIM_DMADelayPulseNCplt() for TIM DMA Delay Pulse complete callback (complementary channel)
  - Implement TIM channel state management mechanism
    - Add new macro
      - TIM_CHANNEL_STATE_SET_ALL and TIM_CHANNEL_N_STATE_SET_ALL
      - TIM_CHANNEL_STATE_SET and TIM_CHANNEL_N_STATE_SET
      - TIM_CHANNEL_STATE_GET and TIM_CHANNEL_N_STATE_GET
  - Add new API HAL_TIM_GetActiveChannel()
  - Add new API HAL_TIM_GetChannelState() to get actual state of the TIM channel
  - Add a new structure for TIM channel States definition : HAL_TIM_ChannelStateTypeDef
  - Update __HAL_TIM_RESET_HANDLE_STATE to support ChannelState and ChannelNState
  - Add a new element in the TIM_HandleTypeDef structure : ChannelState to manage TIM channel operation state
  - Add a new element in the TIM_HandleTypeDef structure : ChannelNState to manage TIM complementary channel operation state
  - Update HAL_TIMEx_MasterConfigSynchronization() API to avoid functional errors and assert fails when using some TIM instances as input trigger.
    - Replace IS_TIM_SYNCHRO_INSTANCE() macro by IS_TIM_MASTER_INSTANCE() macro.
    - Add IS_TIM_SLAVE_INSTANCE() macro to check on TIM_SMCR_MSM bit.
  - Remove ‘register’ storage class specifier from LL TIM driver.
  - Add new API HAL_TIM_DMABurst_MultiWriteStart() allowing to configure the DMA Burst to transfer multiple Data from the memory to the TIM peripheral
  - Add new API HAL_TIM_DMABurst_MultiReadStart() allowing to configure the DMA Burst to transfer Data from the TIM peripheral to the memory
- HAL/LL USB driver
  - Bug fix: USB_ReadPMA() and USB_WritePMA() by ensuring 16-bits access to USB PMA memory
  - Bug fix: correct USB RX count calculation
  - Fix USB Bulk transfer double buffer mode
  - Remove register keyword from USB defined macros as no more supported by C++ compiler
  - Minor rework on USBD_Start() and USBD_Stop() APIs: stopping device will be handled by HAL_PCD_DeInit() API.
  - Remove non used API for USB device mode.
- LL UTILS driver
  - UTILS_SetFlashLatency() API renamed to LL_SetFlashLatency() and set exportable.

V1.2.4 / 31-December-2019

## Main Changes

- General updates to fix known defects and enhancements implementation
- HAL/LL GPIO update
  - Update GPIO initialization sequence to avoid unwanted pulse on GPIO Pin’s
- HAL I2C update
  - Update HAL_I2C_EV_IRQHandler() API to fix I2C send break issue
    - Add additional check on hi2c->hdmatx, hdmatx->XferCpltCallback, hi2c->hdmarx, hdmarx->XferCpltCallback in I2C_Master_SB() API to avoid enabling DMA request when IT mode is used.
  - Update HAL_I2C_ER_IRQHandler() API to fix acknowledge failure issue with I2C memory IT processes
    - Add stop condition generation when NACK occurs.
  - Update HAL_I2C_Init() API to force software reset before setting new I2C configuration.
  - Update HAL I2C processes to report ErrorCode when wrong I2C start condition occurs
    - Add new ErrorCode define: HAL_I2C_WRONG_START
    - Set ErrorCode parameter in I2C handle to HAL_I2C_WRONG_START
  - Update I2C_DMAXferCplt(), I2C_DMAError() and I2C_DMAAbort() APIs to fix hardfault issue when hdmatx and hdmarx parameters in i2c handle aren’t initialized (NULL pointer).
    - Add additional check on hi2c->hdmtx and hi2c->hdmarx before resetting DMA Tx/Rx complete callbacks.
- HAL IRDA update
  - Update IRDA interruption handler to manage correctly the overrun interrupt
    - Add in the HAL_IRDA_IRQHandler() API a check on USART_CR1_RXNEIE bit when an overrun interrupt occurs.
- HAL SMARTCARD update
  - Update SMARTCARD interruption handler to manage correctly the overrun interrupt.
    - Add in the HAL_SMARTCARD_IRQHandler() API a check on USART_CR1_RXNEIE bit when an overrun interrupt occurs.
- HAL UART update
  - Update UART polling processes to handle efficiently the Lock mechanism
    - Move the process unlock at the top of the HAL_UART_Receive() and HAL_UART_Transmit() API.
  - Update UART interruption handler to manage correctly the overrun interrupt
    - Add in the HAL_UART_IRQHandler() API a check on USART_CR1_RXNEIE bit when an overrun interrupt occurs.
- HAL USART update
  - Update USART interruption handler to manage correctly the overrun interrupt
    - Add in the HAL_USART_IRQHandler() API a check on USART_CR1_RXNEIE bit when an overrun interrupt occurs.

V1.2.3 / 26-June-2019

## Main Changes

- General updates to fix known defects and enhancements implementation
- HAL drivers clean up: remove double casting ‘uint32_t’ and ‘U’
- General updates to fix CodeSonar compilation warnings
- General updates to fix the user manual .chm files
- Add support of HAL callback registration feature
- Add new HAL EXTI driver
- The following changes done on the HAL drivers require an update on the application code based on older HAL versions
  - HAL/LL Generic update
    - Add support of HAL callback registration feature
      - The feature disabled by default is available for the following HAL drivers:
        - ADC, CAN, CRYP, DAC, DCMI, ETH, HASH, HCD, I2C, UART, USART, IRDA, SMARTCARD,
        - MMC, NAND, NOR, PCCARD, PCD, RNG, RTC, SD, SRAM, SPI, I2S, TIM and WWDG
      - The feature may be enabled individually per HAL PPP driver by setting the corresponding definition USE_HAL_PPP_REGISTER_CALLBACKS to 1U in stm32f2xx_hal_conf.h project configuration file (template file stm32f2xx_hal_conf_template.h available from Drivers/STM32F2xx_HAL_Driver/Inc)
      - Once enabled , the user application may resort to HAL_PPP_RegisterCallback() to register specific callback function(s) and unregister it(them) with HAL_PPP_UnRegisterCallback()
  - Rework of HAL CRYP driver (compatibility break)
    - HAL CRYP driver has been redesigned with new API’s, to bypass limitations on data Encryption/Decryption management present with previous HAL CRYP driver version.
    - The new HAL CRYP driver is the recommended version. It is located as usual in Drivers/STM32F2xx_HAL_Driver/Src and Drivers/STM32f2xx_HAL_Driver/Inc folders. It can be enabled through switch HAL_CRYP_MODULE_ENABLED in stm32f2xx_hal_conf.h
    - The legacy HAL CRYP driver is no longer supported.
  - Rework of HAL CAN driver (compatibility break)
    - A new HAL CAN driver has been redesigned with new APIs, to bypass limitations on CAN Tx/Rx FIFO management present with previous HAL CAN driver version.
    - The new HAL CAN driver is the recommended version. It is located as usual in Drivers/STM32F2xx_HAL_Driver/Src and Drivers/STM32f2xx_HAL_Driver/Inc folders. It can be enabled through switch HAL_CAN_MODULE_ENABLED in stm32f2xx_hal_conf.h
    - The legacy HAL CAN driver is also present in the release in Drivers/STM32F2xx_HAL_Driver/Src/Legacy and Drivers/STM32F2xx_HAL_Driver/Inc/Legacy folders for software compatibility reasons. Its usage is not recommended as deprecated. It can however be enabled through switch HAL_CAN_LEGACY_MODULE_ENABLED in stm32f2xx_hal_conf.h
- HAL/LL Generic update
  - Update HAL driver to allow user to change systick period to 1ms, 10 ms or 100 ms :
    - Add the following API’s :
      - HAL_GetTickPrio(): Returns a tick priority.
      - HAL_SetTickFreq(): Sets new tick frequency.
      - HAL_GetTickFreq(): Returns tick frequency.
    - Add HAL_TickFreqTypeDef enumeration for the different Tick Frequencies: 10 Hz, 100 Hz and 1KHz (default).
  - Add UNUSED() macro implementation to avoid GCC warning
    - The warning is detected when the UNUSED() macro is called from C++ file
  - General updates to fix MISRA 2012 compilation errors
    - HAL_IS_BIT_SET()/HAL_IS_BIT_CLR() macros implementation update
    - “stdio.h” include updated with “stddef.h”
  - Add HAL_GetUIDw0(), HAL_GetUIDw1() and HAL_GetUIDw2() API in order to returns the unique device identifier
- HAL CAN update
  - Fields of CAN_InitTypeDef structure are reworked:
    - SJW to SyncJumpWidth, BS1 to TimeSeg1, BS2 to TimeSeg2, TTCM to TimeTriggeredMode, ABOM to AutoBusOff, AWUM to AutoWakeUp, NART to AutoRetransmission (inversed), RFLM to ReceiveFifoLocked and TXFP to TransmitFifoPriority
  - Rename CAN_FilterConfTypeDef structure to CAN_FilterTypeDef and update some fields:
    - FilterNumber to FilterBank
    - BankNumber to SlaveStartFilterBank
  - Rename CanTxMsgTypeDef structure to CAN_TxHeaderTypeDef and update some fields:
    - Data to TransmitGlobalTime
  - Rename CanRxMsgTypeDef structure to CAN_RxHeaderTypeDef and update some fields:
    - Data to Timestamp
    - FMI to FilterMatchIndex
  - Update possible values list for FilterActivation parameter in CAN_FilterTypeDef structure
    - CAN_FILTER_ENABLE instead of ENABLE
    - CAN_FILTER_DISABLE instead of DISABLE
  - HAL_CAN_Init() is split into both HAL_CAN_Init() and HAL_CAN_Start() API’s
  - HAL_CAN_Transmit() is replaced by HAL_CAN_AddTxMessage() to place Tx Request, then HAL_CAN_GetTxMailboxesFreeLevel() for polling until completion.
  - HAL_CAN_Transmit_IT() is replaced by HAL_CAN_ActivateNotification() to enable transmit IT, then HAL_CAN_AddTxMessage() for place Tx request.
  - HAL_CAN_Receive() is replaced by HAL_CAN_GetRxFifoFillLevel() for polling until reception, then HAL_CAN_GetRxMessage()
  - to get Rx message.
  - HAL_CAN_Receive_IT() is replaced by HAL_CAN_ActivateNotification() to enable receive IT, then HAL_CAN_GetRxMessage()
  - in the receive callback to get Rx message
  - HAL_CAN_Slepp() is renamed as HAL_CAN_RequestSleep()
  - HAL_CAN_TxCpltCallback() is split into HAL_CAN_TxMailbox0CompleteCallback(), HAL_CAN_TxMailbox1CompleteCallback() and HAL_CAN_TxMailbox2CompleteCallback().
  - HAL_CAN_RxCpltCallback is split into HAL_CAN_RxFifo0MsgPendingCallback() and HAL_CAN_RxFifo1MsgPendingCallback().
  - More complete “How to use the new driver” is detailed in the driver header section itself.
  - Refer to the following example to identify the changes
- HAL CRC update
  - Update __HAL_CRC_DR_RESET() macro
  - Update HAL_CRC_DeInit() API to
    - Be able to return HAL status when CRC is is already busy
    - DeInit the low level hardware after reset IDR register content
  - Remove extra call to HAL_LOCK/HAL_UNLOCK from the followings API’s:
    - HAL_CRC_Accumulate()
    - HAL_CRC_Calculate()
- HAL CRYP update
  - The CRYP_InitTypeDef is no more supported, changed by CRYP_ConfigTypedef to allow changing parameters
  - Using HAL_CRYP_setConfig() API without reinitialize the CRYP IP using the HAL_CRYP_Init() API
  - New parameters added in the CRYP_ConfigTypeDef structure: B0 and DataWidthUnit
  - Input data size and error code parameters are added in the CRYP_HandleTypeDef structure
  - Add new APIs to manage the CRYP configuration:
    - HAL_CRYP_SetConfig()
    - HAL_CRYP_GetConfig()
  - Add new APIs to encrypt and decrypt data:
    - HAL_CRYP_Encypt()
    - HAL_CRYP_Decypt()
    - HAL_CRYP_Encypt_IT()
    - HAL_CRYP_Decypt_IT()
    - HAL_CRYP_Encypt_DMA()
    - HAL_CRYP_Decypt_DMA()
  - More complete “How to use the new driver” is detailed in the driver header section itself.
  - Refer to the following example to identify the changes
- HAL DAC update
  - Overall rework of the driver for a more efficient implementation
    - Update HAL_DAC_Start(), HAL_DAC_Start_DMA(), HAL_DAC_Stop_DMA() and HAL_DAC_ConfigChannel() API to
      - Update lock mechanism for DAC process
      - Optimize code by using direct register read
    - Update HAL_DAC_IRQHandler() function to
      - Add error management in case DMA errors through HAL_DAC_DMAUnderrunCallbackCh1() and HAL_DACEx_DMAUnderrunCallbackCh2()
      - Optimize code by using direct register read
- HAL DCMI update
  - Update HAL_DCMI_Start_DMA() function to Enable the DCMI peripheral
  - Add new timeout implementation based on cpu cycles for DCMI stop
  - Update lock mechanism for DCMI process
  - Update HAL_DCMI_IRQHandler() function to:
    - Optimize code by using direct register read
  - The extension files stm32f2xx_hal_dcmi_ex.c/.h is added and kept empty for projects compatibility reason
  - Add DCMI_SyncUnmaskTypeDef structure and HAL_DCMI_ConfigSyncUnmask() API to manage embedded synchronization delimiters unmasks
  - HAL DCMI driver clean-up: remove non referenced callback APIs: HAL_DCMI_VsyncCallback() and HAL_DCMI_HsyncCallback()
- HAL DMA update
  - Add clean of callbacks in HAL_DMA_DeInit() API
  - Remove FIFO error enabling in “HAL_DMA_Start_IT”
    - when FIFO error monitoring is requested in IT model, the macro __HAL_DMA_ENABLE_IT can be used to enable the FIFO error IT at the user Msp functio
- HAL FLASH update
  - HAL_FLASH_Unlock() update to return state error when the FLASH is already unlocked
- HAL GPIO update
  - HAL_GPIO_TogglePin() API implementation update: to improve robustness
  - HAL_GPIO_DeInit() API update to ensure clear all GPIO EXTI pending interrupts.
- HAL HASH update
  - Overall rework of the driver for a more efficient implementation
    - HASH API changes for MISRA-C 2012 compliance
    - Update HASH_Start_DMA() to add check on HASH_CR_MDMAT bit before checking input buffer length in case of multi-buffer processing
    - Fill-up empty statement in HAL_HASH_DMAFeed_ProcessSuspend() to correct CodeSonar warning
- HAL I2C update
  - I2C API changes for MISRA-C 2012 compliance:
    - Rename HAL_I2C_Master_Sequential_Transmit_IT() to HAL_I2C_Master_Seq_Transmit_IT()
    - Rename HAL_I2C_Master_Sequentiel_Receive_IT() to HAL_I2C_Master_Seq_Receive_IT()
    - Rename HAL_I2C_Slave_Sequentiel_Transmit_IT() to HAL_I2C_Slave_Seq_Transmit_IT()
    - Rename HAL_I2C_Slave_Sequentiel_Receive_DMA() to HAL_I2C_Slave_Seq_Receive_DMA()
  - Add support of I2C repeated start feature in DMA Mode With the following new API’s
    - HAL_I2C_Master_Seq_Transmit_DMA()
    - HAL_I2C_Master_Seq_Receive_DMA()
    - HAL_I2C_Slave_Seq_Transmit_DMA()
    - HAL_I2C_Slave_Seq_Receive_DMA()
  - Add new I2C transfer options to easy manage the sequential transfers
    - I2C_OTHER_FRAME
    - I2C_OTHER_AND_LAST_FRAME
  - Fix I2C send break issue in IT processes
    - Add additional check on hi2c->hdmatxand hi2c->hdmarx to avoid the DMA request enable when ITmode is used.
- HAL UART/USART/IrDA/SMARTCARD update
  - Overall rework of the driver for a more efficient implementation
    - Improve I/O operation functions: separate transfer process and PPP state management
    - Update the HAL_PPP_IRQHandler function by optimizing the management of interrupt errors
    - Align driver with the Reference Manual regarding registers and bit definition naming
- LL IWDG update
  - Update LL inline macros to use IWDGx parameter instead of IWDG instance defined in CMSIS device
- HAL RNG update
  - Add ErrorCode parameter in HAL RNG Handler structure
  - Add HAL_RNG_GetError() API
  - HAL Lock/Unlock mecanism update
- HAL/LL RTC update
  - HAL/ LL drivers optimization
    - HAL driver: remove unused variables
    - LL driver: getter APIs optimization
- HAL/LL RCC update
  - Update HAL_RCC_DeInit() and LL_RCC_DeInit() APIs to
    - Be able to return HAL/LL status
    - Add checks for HSI, PLL and PLLI2S ready before modifying RCC CFGR registers
    - Clear all interrupt flags
    - Initialize systick interrupt period
- HAL SDMMC update
  - Add API HAL_SD_ConfigSpeedBusOperation() to configure the SD card speed bus mode
  - Fix and improve state and error management
  - Fix preprocessing compilation issue with SDIO STA STBITERR interrupt
  - Align driver with the Reference Manual regarding registers and bit definition naming
- HAL SPI update
  - Overall rework of the driver for a more efficient implementation
    - Add the following new macros:
      - SPI_CHECK_FLAG()
      - SPI_CHECK_IT_SOURCE()
    - Update HAL_SPI_StateTypeDef structure to add new state: HAL_SPI_STATE_ABORT
    - Add HAL_SPI_Abort() to manage abort issue in SPI TX or Rx mode only
    - Update HAL_SPI_Transmit()/HAL_SPI_Receive() API’s to fix memory overflow issue.
    - Update HAL_SPI_Transmit_DMA : checking hmdtx instead of hdmrx.
    - Update HAL_SPI_IRQHandler() function to
      - Add error management in case DMA errors through HAL_DMA_Abort_IT() and ErrorCallback()
      - Optimize code by using direct register read
    - Align driver with the Reference Manual regarding registers and bit definition naming
- HAL I2S update
  - Overall rework of the driver for a more efficient implementation
    - Add the following new macros:
      - I2S_CHECK_FLAG()
      - I2S_CHECK_IT_SOURCE()
    - Update HAL_I2S_Transmit()/HAL_I2S_Receive() API’s to fix memory overflow issue
    - Update HAL_SPI_IRQHandler() function to
      - Add error management in case DMA errors through HAL_DMA_Abort_IT() and ErrorCallback()
      - Optimize code by using direct register read
    - Add extra call to HAL_LOCK/HAL_UNLOCK to the followings API’s:
      - HAL_I2S_Transmit()
      - HAL_I2S_Receive()
      - HAL_I2S_Transmit_IT()
      - HAL_I2S_Receive_IT()
      - HAL_I2S_Transmit_DMA()
      - HAL_I2S_Receive_DMA()
    - Align driver with the Reference Manual regarding registers and bit definition naming
- HAL/LL TIM update
  - Move the following TIM structures from stm32f4xx_hal_tim_ex.h into stm32f4xx_hal_tim.h
    - TIM_MasterConfigTypeDef()
    - TIM_BreakDeadTimeConfigTypeDef()
  - Add new TIM Callbacks API’s:
    - HAL_TIM_PeriodElapsedHalfCpltCallback()
    - HAL_TIM_IC_CaptureHalfCpltCallback()
    - HAL_TIM_PWM_PulseFinishedHalfCpltCallback()
    - HAL_TIM_TriggerHalfCpltCallback()
  - TIM API changes for MISRA-C 2012 compliance:
    - Rename HAL_TIM_SlaveConfigSynchronization to HAL_TIM_SlaveConfigSynchro
    - Rename HAL_TIM_SlaveConfigSynchronization_IT to HAL_TIM_SlaveConfigSynchro_IT
    - Rename HAL_TIMEx_ConfigCommutationEvent to HAL_TIMEx_ConfigCommutEvent
    - Rename HAL_TIMEx_ConfigCommutationEvent_IT to HAL_TIMEx_ConfigCommutEvent_IT
    - Rename HAL_TIMEx_ConfigCommutationEvent_DMA to HAL_TIMEx_ConfigCommutEvent_DMA
    - Rename HAL_TIMEx_CommutationCallback to HAL_TIMEx_CommutCallback
    - Rename HAL_TIMEx_DMACommutationCplt to TIMEx_DMACommutationCplt
  - Add a call to HAL_DMA_Abort_IT from HAL_TIM_XXX_Stop_DMA
- HAL/LL USB update
  - Rework USB interrupt handler and improve HS DMA support in Device mode
  - Fix BCD handling for OTG instance in device mode
  - cleanup reference to low speed in device mode
  - Allow writing TX FIFO in case of transfer length is equal to available space in the TX FIFO
  - Fix Toggle OUT interrupt channel in host mode
  - Add new callback to be used to handle usb device connection/disconnection
    - HAL_HCD_PortEnabled_Callback()
    - HAL_HCD_PortDisabled_Callback()
  - Update to prevent reactivate host interrupt channel
  - Updated USB_WritePacket(), USB_ReadPacket()APIs to prevent compilation warning with GCC GNU v8.2.0
  - Rework USB_EPStartXfer() API to enable theUSB endpoint before unmasking the TX FiFo empty interrupt in case DMA is not used
  - USB HAL_HCD_Init() and HAL_PCD_Init() APIsupdated to avoid enabling USB DMA feature for OTG FS instance, USB DMAfeature is available only on OTG HS Instance
  - Remove duplicated line in hal_hcd.c header file comment section
  - Rework USB HAL driver to use instancePCD_SPEED_xxx, HCD_SPEED_xx speeds instead of OTG register Core speed definition during the instance initialization
  - Software Quality improvement with a fix ofCodeSonar warning on PCD_Port_IRQHandler() and HCD_Port_IRQHandler()interrupt handlers
- HAL UTILS update
  - Update LL_GetFlashSize() API to return uint32_t instead of uint16_t

V1.2.2 / 29-September-2017

## Main Changes

- General updates to fix known defects and enhancements implementation
- Fix compilation warning with GCC compiler
- Remove Date and version from header files
- HAL Generic update
  - Update __weak and __packed defined values for ARM compiler
  - Update __ALIGN_BEGIN and __ALIGN_END defined values for ARM compiler
- HAL I2C update
  - Update Interface APIs headers to remove confusing message about device address
  - UpdateI2C_MasterReceive_RXNE() and I2C_MasterReceive_BTF() static APIs to fix badHandling of NACK in I2C master receive process.
- HAL RCC update
  - Update HAL_RCC_GetOscConfig()API to:
    - set PLLR in theRCC_OscInitStruct
    - check on null pointer
    - Update HAL_RCC_ClockConfig()API to:
    - check on null pointer
    - optimize code size byupdating the handling method of the SWS bits
    - update to use __HAL_FLASH_GET_LATENCY() flash macro instead of using direct registeraccess to LATENCY bits in FLASH ACR register.
  - Update HAL_RCC_DeInit() to
    - Be able to return HAL status (HAL_OK, HAL_TIMEOUT and HAL_ERROR)
    - Add checks for HSI, PLL and PLLI2S ready before modifying RCC CFGR registers
    - Clear all interrupt falgs
    - Initialize systick interrupt period
  - Update HAL_RCC_GetSysClockFreq() to avoid risk of rounding error which may leads to a wrong returned value.
- HAL RNG update
  - HAL_RNG_Init() remove Lock()/Unlock()
- HAL MMC update
  - HAL_MMC_Erase() API: add missing () to fix compilation warning detected with SW4STM32 when extra feature is enabled.
- LL DMA update
  - Update to clear DMA flags using WRITE_REG() instead SET_REG() API to avoid read access to the IFCR register that is write only.
  - Update values for the following defines: DMA_FLAG_FEIF0_4 and DMA_FLAG_DMEIF0_4
- LL RTC update
  - Fix warning with static analyzer
- LL USART update
  - Add assert macros to check USART BaudRate register
- LL I2C update
  - Rename IS_I2C_CLOCK_SPEED()and IS_I2C_DUTY_CYCLE() respectively to IS_LL_I2C_CLOCK_SPEED() andIS_LL_I2C_DUTY_CYCLE() to avoid incompatible macros redefinition.

V1.2.1 / 14-April-2017

## Main Changes

- General updates to fix known defects and enhancements implementation
- HAL CONF Template update
  - Add support for HAL MMC driver.
- HAL CAN update
  - Addmanagement of overrun error.
  - Allowpossibility to receive messages from the 2 RX FIFOs in parallel viainterrupt.
  - Fix messagelost issue with specific sequence of transmit requests.
  - Handletransmission failure with error callback, when NART is enabled.
  - Add __HAL_CAN_CANCEL_TRANSMIT() call to abort transmission whentimeout is reached

V1.2.0 / 17-March-2017

## Main Changes

- Add Low Layer drivers allowing performance and footprint optimization
  - Low Layer drivers APIs provide register level programming: require deep knowledge of peripherals described in STM32F2xx Reference Manuals
  - Low Layer drivers are available for: ADC, Cortex, CRC, DAC, DMA, EXTI, GPIO, I2C, IWDG, PWR, RCC, RNG, RTC, SPI, TIM, USART, WWDG peripherals and additionnal Low Level Bus, System and Utilities APIs.
  - Low Layer drivers APIs are implemented as static inline function in new Inc/stm32f2xx_ll_ppp.h files for PPP peripherals, there is no configuration file and each stm32f2xx_ll_ppp.h file must be included in user code.
- General updates to fix known defects and enhancements implementation
- Fix extra warnings with GCC compiler
- HAL drivers clean up: remove double casting ‘uint32_t’ and ‘U’
- Add new HAL MMC driver
- The following changes done on the HAL drivers require an update on the application code based on older HAL versions
  - HAL SD update
    - Overall rework of the driver for a more efficient implementation
      - Modify initialization API and structures
      - Modify Read / Write sequences: separate transfer process and SD Cards state management
      - Adding interrupt mode for Read / Write operations
      - Update the HAL_SD_IRQHandler function by optimizing the management of interrupt errors
    - Refer to the following example to identify the changes: BSP example and USB_Device/MSC_Standalone application
  - HAL NAND update
  - Modify NAND_AddressTypeDef, NAND_DeviceConfigTypeDef and NAND_HandleTypeDef structures fields
  - Add new HAL_NAND_ConfigDevice API
- HAL update
  - Modifiy default HAL_Delay implementation to guarantee minimum delay
  - Add HAL_GetUID API : returns the unique device identifier
- HAL Cortex update
  - Move HAL_MPU_Disable() and HAL_MPU_Enable() from stm32f2xx_hal_cortex.h to stm32f2xx_hal_cortex.c
  - Clear the whole MPU control register in HAL_MPU_Disable() API
- HAL FLASH update
  - IS_FLASH_ADDRESS() macro update to support OTP range
  - FLASH_Program_DoubleWord(): Replace 64-bit accesses with 2 double-words operations
- HAL GPIO update
  - Update IS_GPIO_PIN() macro implementation to be more safe
- HAL RCC update
  - Update IS_RCC_PLLQ_VALUE() macro implementation: the minimum accepted value is 2 instead of 4
  - Update to refer to AHBPrescTable[] and APBPrescTable[] tables defined in system_stm32f2xx.c file instead of APBAHBPrescTable[] table.
- HAL DMA update
  - HAL_DMA_Init(): update to check compatibility between FIFO threshold level and size of the memory burst
- HAL UART/USART/IrDA/SMARTCARD (referenced as PPP here below)
  - DMA Receive process; the code has been updated to clear the PPP OVR flag before enabling DMA receive request.
  - Add transfer abort APIs and associated callbacks :
    - HAL_PPP_Abort()
    - HAL_PPP_AbortTransmit()
    - HAL_PPP_AbortReceive()
    - HAL_PPP_Abort_IT()
    - HAL_PPP_AbortTransmit_IT()
    - HAL_PPP_AbortReceive_IT()
    - HAL_PPP_AbortCpltCallback()
    - HAL_PPP_AbortTransmitCpltCallback()
    - HAL_PPP_AbortReceiveCpltCallback()
- HAL CAN update
  - Remove Lock mechanism from HAL_CAN_Transmit_IT() and HAL_CAN_Receive_IT() processes
  - HAL CAN driver optimization
- HAL TIM update
  - Add __HAL_TIM_MOE_DISABLE_UNCONDITIONALLY() macro to disable Master output without check on TIM channel state.
  - Update HAL_TIMEx_ConfigBreakDeadTime() to fix TIM BDTR register corruption.
- HAL I2C update
  - Update HAL_I2C_Master_Transmit() and HAL_I2C_Slave_Transmit() to avoid sending extra bytes at the end of the transmit processes
  - UpdateHAL_I2C_Mem_Read() API to fix wrong check on misused parameter “Size”
  - UpdateI2C_MasterReceive_RXNE() and I2C_MasterReceive_BTF() static APIs toenhance Master sequential reception process.
- HAL SPI update
  - Add transfer abort APIs and associated callbacks in interrupt mode
    - HAL_SPI_Abort()
    - HAL_SPI_Abort_IT()
    - HAL_SPI_AbortCpltCallback()
- HAL USB PCD update
  - Flush all TX FIFOs on USB Reset
  - Remove Lock mechanism from HAL_PCD_EP_Transmit() and HAL_PCD_EP_Receive() API’s
- LL USB update
  - Enable DMA Burst mode for USB OTG HS
  - Fix SD card detection issue
- LL SDMMC update
  - Add new SDMMC_CmdSDEraseStartAdd, SDMMC_CmdSDEraseEndAdd, SDMMC_CmdOpCondition and SDMMC_CmdSwitch functions

V1.1.3 / 29-June-2016

## Main Changes

- General updates to fix known defects and enhancements implementation
- Enhance HAL delay and time base implementation:
  - Add new drivers stm32f2xx_hal_timebase_tim_template.c, stm32f2xx_hal_timebase_rtc_alarm_template.c and stm32f2xx_hal_timebase_rtc_wakeup_template.c which override the native HAL time base functions (defined as weak) to either use the TIM or the RTC as time base tick source. For more details about the usage of these drivers, please refer to HAL_TimeBase examples and FreeRTOS-based applications
- The following changes done on the HAL drivers require an update on the application code based on HAL V1.1.2
  - HAL UART, USART, IRDA, SMARTCARD, SPI, I2C (referenced as PPP here below) drivers
    - Add PPP error management during DMA process. This requires the following updates on user application:
      - Configure and enable the PPP IRQ in HAL_PPP_MspInit() function
      - In stm32f2xx_it.c file, PPP_IRQHandler() function: add a call to HAL_PPP_IRQHandler() function
      - Add and customize the Error Callback API: HAL_PPP_ErrorCallback()
    - HAL I2C driver:◾Update to avoid waiting on STOPF/BTF/AF flag under DMA ISR by using the PPP end of transfer interrupt in theDMA transfer process. This requires the following updates on user application:
      - Configure and enable the PPP IRQ in HAL_PPP_MspInit() function
      - In stm32f2xx_it.c file, PPP_IRQHandler() function: add a call to HAL_PPP_IRQHandler() function
    - I2C transfer processes IT update: NACK during addressing phase is managed through I2C Error interrupt instead of HAL state
  - HAL IWDG driver: rework overall driver for better implementation
    - Remove HAL_IWDG_Start(), HAL_IWDG_MspInit() and HAL_IWDG_GetState() APIs
  - HAL WWDG driver: rework overall driver for better implementation
    - Remove HAL_WWDG_Start(), HAL_WWDG_Start_IT(), HAL_WWDG_MspDeInit() and HAL_WWDG_GetState() APIs
    - Update the HAL_WWDG_Refresh(WWDG_HandleTypeDef *hwwdg, uint32_t counter) function and API by removing the “counter” parameter
- HAL Generic update
  - stm32f2xx_hal_conf_template.h
    - Optimize HSE Startup Timeout value from 5000ms to 100 ms
    - Add new define LSE_STARTUP_TIMEOUT
    - Add new define USE_SPI_CRC for code cleanup when the CRC calculation is disabled.
  - Update HAL drivers to support MISRA C 2004 rule 10.6
  - Add new template driver to configure timebase using TIMER :
    - stm32f2xx_hal_timebase_tim_template.c
- HAL CAN update
  - Update HAL_CAN_Transmit() and HAL_CAN_Transmit_IT() functions to unlock process when all Mailboxes are busy
- HAL DCMI update
  - Rename DCMI_DMAConvCplt to DCMI_DMAXferCplt
  - Update HAL_DCMI_Start_DMA() function to Enable the DCMI peripheral
  - Add new timeout implementation based on cpu cycles for DCMI stop
  - Add HAL_DCMI_Suspend() function to suspend DCMI capture
  - Add HAL_DCMI_Resume() function to resume capture after DCMI suspend
  - Update lock mechanism for DCMI process
  - Update HAL_DCMI_IRQHandler() function to
    - Add error management in case DMA errors through XferAbortCallback() and HAL_DMA_Abort_IT()
    - Optimize code by using direct register read
- HAL DMA update
  - Add new APIs HAL_DMA_RegisterCallback() and HAL_DMA_UnRegisterCallback to register/unregister the different callbacks identified by the enum typedef HAL_DMA_CallbackIDTypeDef
  - Add new API HAL_DMA_Abort_IT() to abort DMA transfer under interrupt context
    - The new registered Abort callback is called when DMA transfer abortion is completed
  - Add the check of compatibility between FIFO threshold level and size of the memory burst in the HAL_DMA_Init() API
  - Add new Error Codes: HAL_DMA_ERROR_PARAM, HAL_DMA_ERROR_NO_XFER and HAL_DMA_ERROR_NOT_SUPPORTED
  - Remove all DMA states related to MEM0/MEM1 in HAL_DMA_StateTypeDef
- HAL ETH update
  - Removal of ETH MAC debug register defines
- HAL HCD update
  - Update HCD_Port_IRQHandler() to unmask disconnect IT only when the port is disable
- HAL I2C update
  - Add support of I2C repeated start feature:
    - With the following new API’s
      - HAL_I2C_Master_Sequential_Transmit_IT()
      - HAL_I2C_Master_Sequential_Receive_IT()
      - HAL_I2C_Master_Abort_IT()
      - HAL_I2C_Slave_Sequential_Transmit_IT()
      - HAL_I2C_Slave_Sequential_Receive_IT()
      - HAL_I2C_EnableListen_IT()
      - HAL_I2C_DisableListen_IT()
    - Add new user callbacks:
      - HAL_I2C_ListenCpltCallback()
      - HAL_I2C_AddrCallback()
  - Update to generate STOP condition when a acknowledge failure error is detected
  - Several update on HAL I2C driver to implement the new I2C state machine:
    - Add new API to get the I2C mode: HAL_I2C_GetMode()
    - Update I2C process to manage the new I2C states.
  - Fix wrong behaviour in single byte transmission
  - Update I2C_WaitOnFlagUntilTimeout() to manage the NACK feature.
  - Update I2C transmission process to support the case data size equal 0
  - Update Polling management:
    - The Timeout value must be estimated for the overall process duration: the Timeout measurement is cumulative
  - Add the management of Abort service: Abort DMA transfer through interrupt
    - In the case of Master Abort IT transfer usage:
      - Add new user HAL_I2C_AbortCpltCallback() to inform user of the end of abort process
      - A new abort state is defined in the HAL_I2C_StateTypeDef structure
  - Add the management of I2C peripheral errors, ACK failure and STOP condition detection during DMA process. This requires the following updates on user application:
    - Configure and enable the I2C IRQ in HAL_I2C_MspInit() function
    - In stm32f2xx_it.c file, I2C_IRQHandler() function: add a call to HAL_I2C_IRQHandler() function
    - Add and customize the Error Callback API: HAL_I2C_ErrorCallback()
  - NACK error during addressing phase is returned through interrupt instead of previously through I2C transfer API’s
  - I2C addressing phase is updated to be managed using interrupt instead of polling (Only for HAL I2C driver)
    - Add new static functions to manage I2C SB, ADDR and ADD10 flags
- HAL IRDA update
  - Several update on HAL IRDA driver to implement the new UART state machine:
    - Add new field in IRDA_HandleTypeDef structure: “rxState”, IRDA state information related to Rx Operations
    - Rename “state” field in UART_HandleTypeDef structure by “gstate”: IRDA state information related to global Handle management and Tx Operations
    - Update IRDA process to manage the new UART states.
    - Update __HAL_IRDA_RESET_HANDLE_STATE() macro to handle the new IRDA state parameters (gState, rxState)
  - Removal of IRDA_TIMEOUT_VALUE define
  - Update IRDA_BRR() Macro to fix wrong baudrate calculation
  - Update Polling management:
    - The user Timeout value must be estimated for the overall process duration: the Timeout measurement is cumulative
  - Update DMA process:
    - Update the management of IRDA peripheral errors during DMA process. This requires the following updates in user application:
      - Configure and enable the IRDA IRQ in HAL_IRDA_MspInit() function
      - In stm32f2xx_it.c file, IRDA_IRQHandler() function: add a call to HAL_IRDA_IRQHandler() function
      - Add and customize the Error Callback API: HAL_IRDA_ErrorCallback()
- HAL IWDG update
  - Overall rework of the driver for a more efficient implementation
    - Remove the following APIs:
      - HAL_IWDG_Start()
      - HAL_IWDG_MspInit()
      - HAL_IWDG_GetState()
    - Update implementation:
      - HAL_IWDG_Init(): this function insures the configuration and the start of the IWDG counter
      - HAL_IWDG_Refresh(): this function insures the reload of the IWDG counter
    - Refer to the following example to identify the changes: IWDG_Example
- HAL NOR update
  - Update NOR_ADDR_SHIFT macro implementation
- HAL PCD update
  - Update HAL_PCD_IRQHandler() to get HCLK frequency before setting TRDT value
- HAL RCC update
  - Add new default define value for HSI calibration “RCC_HSICALIBRATION_DEFAULT”
  - Optimize Internal oscillators and PLL startup timeout
  - Update to avoid the disable for HSE/LSE oscillators before setting the new RCC HSE/LSE configuration and add the following notes in HAL_RCC_OscConfig() API description:
    - - @note Transitions LSE Bypass to LSE On and LSE On to LSE Bypass are not
    - - supported by this API. User should request a transition to LSE Off
    - - first and then LSE On or LSE Bypass.
    - - @note Transition HSE Bypass to HSE On and HSE On to HSE Bypass are not
    - - supported by this API. User should request a transition to HSE Off
    - - first and then HSE On or HSE Bypass.◦Optimize the HAL_RCC_ClockConfig() API implementation
  - Update HAL_RCC_ClockConfig() function to adjust the SystemCoreClock
  - HAL_RCCEx_PeriphCLKConfig() API: update to fix the RTC clock configuration issue
- HAL RTC update
  - Add new timeout implementation based on cpu cycles for ALRAWF, ALRBWF and WUTWF flags
- HAL SMARTCARD update
  - Several update on HAL SMARTCARD driver to implement the new UART state machine:
    - Add new field in SMARTCARD_HandleTypeDef structure: “rxState”, SMARTCARDstate information related to Rx Operations
    - Rename “state” field in UART_HandleTypeDef structure by “gstate”: SMARTCARDstate information related to global Handle management and Tx Operations
    - Update SMARTCARD process to manage the new UART states.
    - Update __HAL_SMARTCARD_RESET_HANDLE_STATE() macro to handle the new SMARTCARD state parameters (gState, rxState)
  - Update SMARTCARD_BRR() macro to fix wrong baudrate calculation
  - Update Polling management:
    - The user Timeout value must be estimated for the overall process duration: the Timeout measurement is cumulative
  - Update DMA process:
    - Update the management of SMARTCARD peripheral errors during DMA process. This requires the following updates in user application:
      - Configure and enable the SMARTCARD IRQ in HAL_SMARTCARD_MspInit() function
      - In stm32f2xx_it.c file, SMARTCARD_IRQHandler() function: add a call to HAL_SMARTCARD_IRQHandler() function
      - Add and customize the Error Callback API: HAL_SMARTCARD_ErrorCallback()
- HAL SPI update
  - Major Update to improve performance in polling/interrupt mode to reach max frequency:
    - Polling mode:
      - Replace use of SPI_WaitOnFlagUnitTimeout() funnction by “if” statement to check on RXNE/TXE flage while transferring data
      - Use API data pointer instead of SPI handle data pointer
      - Use a Goto implementation instead of “if..else” statements
  - Interrupt mode:
    - Minimize access on SPI registers
    - Split the SPI modes into dedicated static functions to minimize checking statements under HAL_IRQHandler():
    - 1lines/2lines modes
    - 8 bit/ 16 bits data formats
    - CRC calculation enabled/disabled
    - Remove waiting loop under ISR when closing the communication
  - All modes
    - Adding switch USE_SPI_CRC to minimize number of statements when CRC calculation is disabled
      - Update Timeout management to check on global process
      - Update Error code management in all processes
      - Update DMA process:◾Add the management of SPI peripheral errors during DMA process. This requires the following updates in the user application:
      - Configure and enable the SPI IRQ in HAL_SPI_MspInit() function
      - In stm32f2xx_it.c file, SPI_IRQHandler() function: add a call to HAL_SPI_IRQHandler() function
      - Add and customize the Error Callback API: HAL_SPI_ErrorCallback()
      - Refer to the following example which describe the changes: SPI_FullDuplex_ComDMA
- HAL UART update
  - Several update on HAL UART driver to implement the new UART state machine:
    - Add new field in UART_HandleTypeDef structure: “rxState”, UART state information related to Rx Operations
    - Rename “state” field in UART_HandleTypeDef structure by “gstate”: UART state information related to global Handle management and Tx Operations
    - Update UART process to manage the new UART states.
    - Update __HAL_UART_RESET_HANDLE_STATE() macro to handle the new UART state parameters (gState, rxState)
  - Update UART_BRR_SAMPLING16() and UART_BRR_SAMPLING8() Macros to fix wrong baudrate calculation.
  - Update Polling management:
    - The user Timeout value must be estimated for the overall process duration: the Timeout measurement is cumulative
  - Update DMA process:
    - Update the management of UART peripheral errors during DMA process. This requires the following updates in user application:
      - Configure and enable the UART IRQ in HAL_UART_MspInit() function
      - In stm32f2xx_it.c file, UART_IRQHandler() function: add a call to HAL_UART_IRQHandler() function
      - Add and customize the Error Callback API: HAL_UART_ErrorCallback()
- HAL USART update
  - Update Polling management:
    - The user Timeout value must be estimated for the overall process duration: the Timeout measurement is cumulative
  - Update DMA process:
    - Update the management of USART peripheral errors during DMA process. This requires the following updates in user application:
      - Configure and enable the USART IRQ in HAL_USART_MspInit() function
      - In stm32f2xx_it.c file, USART_IRQHandler() function: add a call to HAL_USART_IRQHandler() function
      - Add and customize the Error Callback API: HAL_USART_ErrorCallback()
- HAL WWDG update
  - Overall rework of the driver for more efficient implementation
    - Remove the following APIs:
      - HAL_WWDG_Start()
      - HAL_WWDG_Start_IT()
      - HAL_WWDG_MspDeInit()
      - HAL_WWDG_GetState()
    - Update implementation:
      - HAL_WWDG_Init()
      - A new parameter in the Init structure: EWIMode
        - HAL_WWDG_MspInit()
      - HAL_WWDG_Refresh()
        - This function insures the reload of the counter
        - The “counter” parameter has been removed
      - HAL_WWDG_IRQHandler()
      - HAL_WWDG_EarlyWakeupCallback() is the new prototype of HAL_WWDG_WakeUpCallback()
  - Refer to the following example to identify the changes: WWDG_Example

V1.1.2 / 11-December-2015

## Main Changes

- HAL RCC update
  - Fix compilation errors with the __HAL_RCC_DAC_IS_CLK_DISABLED(), __HAL_RCC_CRYP_IS_CLK_DISABLED() and __HAL_RCC_HASH_IS_CLK_DISABLED() macros
- HAL ETH update
  - Update HAL_ETH_Init() function to add timeout on the Software reset management

V1.1.1 / 20-November-2015

## Main Changes

- General updates to fix known defects and enhancements implementation
- One change done on the HAL CRYP requires an update on the application code based on HAL V1.1.0
  - Update HAL_CRYP_DESECB_Decrypt() API to invert pPlainData and pCypherData parameters
- HAL generic update
  - Update HAL weak empty callbacks to prevent unused argument compilation warnings with some compilers by calling the following line:
    - UNUSED(hppp);
  - HSE_STARTUP_TIMEOUT constant has been corrected in stm32f2xx_hal_conf_template.h file, its value changed from 5000 to 100.
- HAL CORTEX update
  - Remove duplication for __HAL_CORTEX_SYSTICKCLK_CONFIG() macro
- HAL HASH update
  - Rename HAL_HASH_STATETypeDef to HAL_HASH_StateTypeDef
  - Rename HAL_HASH_PhaseTypeDef to HAL_HASH_PhaseTypeDef
- HAL RCC update
  - Add new macros __HAL_RCC_PPP_IS_CLK_ENABLED() to check on Clock enable/disable status
  - Update __HAL_RCC_USB_OTG_FS_CLK_DISABLE() macro to remove the disable for the SYSCFG
- HAL FLASH update
  - __HAL_FLASH_INSTRUCTION_CACHE_RESET() macro: update to reset ICRST bit in the ACR register after setting it.
- HAL CRYP update
  - Update HAL_CRYP_DESECB_Decrypt() API to fix the inverted pPlainData and pCypherData parameters issue
- HAL TIM update
  - Update HAL_TIM_ConfigClockSource() API to check only the required parameters
- HAL NAND update
  - Update HAL_NAND_Read_Page()/HAL_NAND_Write_Page()/HAL_NAND_Read_SpareArea() APIs to manage correctly the NAND Page access
- HAL CAN update
  - Update to use “=” instead of “|=” to clear flags in the MSR, TSR, RF0R and RF1R registers
- HAL PCD update
  - Fix typo in __HAL_USB_OTG_HS_WAKEUP_EXTI_ENABLE_RISING_FALLING_EDGE() macro implementation
- LL FSMC update
  - Update the FSMC_NORSRAM_Extended_Timing_Init() API to remove the check on CLKDIvison and DataLatency parameters

V1.1.0 / 09-October-2015

## Main Changes

- Maintenance release to fix known defects and enhancements implementation
- Macros and literals renaming to ensure compatibles across STM32 series, backward compatibility maintained thanks to new added file stm32_hal_legacy.h under /Inc/Legacy
- Add *.chm UM for all drivers
- Update drivers to be C++ compliant
- Several update on source code formatting, for better UM generation (i.e. Doxygen tags updated)
- Four changes done on the HAL requires an update on the application code based on HAL V1.0.1
  - LSI_VALUE constant has been corrected in stm32f2xx_hal_conf.h file, its value changed from 40 KHz to 32 KHz
  - UART, USART, IRDA and SMARTCARD (referenced as PPP here below) drivers: in DMA transmit process, the code has been updated to avoid waiting on TC flag under DMA ISR, PPP TC interrupt is used instead. Below the update to be done on user application:
    - Configure and enable the USART IRQ in HAL_PPP_MspInit() function
    - In stm32f2xx_it.c file, PPP_IRQHandler() function: add a call to HAL_PPP_IRQHandler() function
  - CRYP driver updated to support multi instance,so user must ensure that the new parameter Instance is initialized in his application(CRYPHandle.Instance = CRYP)
  - HASH IT process: update to call the HAL_HASH_InCpltCallback() at the end of the complete buffer instead of every each 512 bits
- HAL generic update
  - stm32f2xx_hal_def.h
    - Remove NULL definition and add include for stdio.h
    - Add UNUSED() macro
    - Add a new define __NOINLINE to be used for the no inline code independent from tool chain
  - stm32f2xx_hal_conf_template.h
    - Add a new define for LSI default value LSI_VALUE
    - Add a new define for LSE default value LSE_VALUE
    - Add a new define for Tick interrupt priority TICK_INT_PRIORITY (needed for the enhanced time base implementation)
  - Enhance HAL delay and time base implementation
    - Systick timer is used by default as source of time base, but user can eventually implement his proper time base source (a general purpose timer for example or other time source)
    - Functions affecting time base configurations are declared as __Weak to make override possible in case of other implementations in user file, for more details please refer to HAL_TimeBase example
  - Fix flag clear procedure: use atomic write operation “=” instead of ready-modify-write operation “|=” or “&=”
  - Fix on Timeout management, Timeout value set to 0 passed to API automatically exits the function after checking the flag without any wait
  - Common update for the following communication peripherals: SPI, UART, USART and IRDA
    - Add DMA circular mode support
    - Remove lock from recursive process
  - Add new macro __HAL_RESET_HANDLE_STATE to reset a given handle state
  - Add a new attribute for functions executed from internal SRAM and depending from Compiler implementation
  - When USE_RTOS == 1 (in stm32f2xx_hal_conf.h), the __HAL_LOCK() is not defined instead of being defined empty
  - Miscellaneous comments and formatting update
  - Update all macros and literals naming to be upper case
  - ErrorCode parameter in PPP_HandleTypeDef structure updated to uint32_t instead of enum HAL_PPP_ErrorTypeDef
  - Remove the unused FLAG and IT assert macros
  - stm32f2xx_hal_ppp.c
    - HAL_PPP_Init(): update to force the HAL_PPP_STATE_RESET before calling the HAL_PPP_MspInit()
  - Important Note: aliases has been added for any API naming change, to keep compatibility with previous version
- HAL ADC update
  - ADC HAL state machine update to use bit fields instead of enum:
    - HAL_ADC_StateTypeDef enum fields are replaced by respective defines
  - Add new literal: ADC_SOFTWARE_START to be used as possible value for the ExternalTrigConv parameter in the ADC_InitTypeDef structure to select the ADC software trigger mode.
  - IS_ADC_CHANNEL() macro update to don’t assert stop the ADC_CHANNEL_TEMPSENSOR value
  - HAL_ADC_PollForConversion(): update to manage particular case when ADC configured in DMA mode and ADC sequencer with several ranks and polling for end of each conversion
  - HAL_ADC_Start()/HAL_ADC_Start_IT() /HAL_ADC_Start_DMA() update:
    - unlock the process before starting the ADC software conversion.
    - Optimize the ADC stabilization delays
  - __HAL_ADC_GET_IT_SOURCE() update macro implementation
  - Add more details in ‘How to use this driver’ section
  - Add new literal: ADC_INJECTED_SOFTWARE_START to be used as possible value for the ExternalTrigInjecConvEdge parameter in the ADC_InitTypeDef structure to select the ADC software trigger mode.
- HAL DAC update
  - Enhance the DMA channelconfiguration when used with DAC
  - HAL_DAC_ConfigChannel(): update the access to the DAC peripheral registers via the hdac handle instance
  - HAL_DAC_IRQHandler(): update to check on both DAC_FLAG_DMAUDR1 and DAC_FLAG_DMAUDR2
  - HAL_DACEx_NoiseWaveGenerate(): update to reset DAC CR register before setting the new DAC configuration
  - HAL_DACEx_TriangleWaveGenerate(): update to reset DAC CR register before setting the new DAC configuration
  - Add new macro to check if the specified DAC interrupt source is enabled or disabled
    - __HAL_DAC_GET_IT_SOURCE()
  - HAL_DACEx_TriangleWaveGeneration() update to use DAC CR bit mask definition
  - HAL_DACEx_NoiseWaveGeneration() update to use DAC CR bit mask definition
- HAL CAN update
  - Unlock the CAN process when communication error occurred
  - CanTxMsgTypeDef structure: update to use uint8_t Data[8] instead of uint32_t Data[8]
  - CanRxMsgTypeDef structure: update to use uint8_t Data[8] instead of uint32_t Data[8]
- HAL CORTEX update
  - Add new macro IS_NVIC_DEVICE_IRQ() to check on negative values of IRQn parameter
  - Add specific API for MPU management
    - add MPU_Region_InitTypeDef structure
    - add new function HAL_MPU_ConfigRegion()
- HAL CRYP update
  - HAL_CRYP_DESECB_Decrypt_DMA(): fix the inverted pPlainData and pCypherData parameters issue
  - Add restriction for the CCM Encrypt/Decrypt API’s that only DataType equal to 8bits is supported
  - Update to manage multi instance:
    - Add new parameter Instance in the CRYP_HandleTypeDef Handle structure.
    - Add new parameter in all HAL CRYP macros
      - example: __HAL_CRYP_ENABLE() updated by __HAL_CRYP_ENABLE(HANDLE)
- HAL DCMI update
  - HAL_DCMI_ConfigCROP(): Invert assert macros to check Y0 and Ysize parameters
- HAL DMA update
  - Overall driver update for code optimization
  - add StreamBaseAddress and StreamIndex new fields in the DMA_HandleTypeDef structure
  - add DMA_Base_Registers private structure
  - add static function DMA_CalcBaseAndBitshift()
    - update HAL_DMA_Init() function to use the new added static function
    - update HAL_DMA_DeInit() function to optimize clear flag operations
    - update HAL_DMA_Start_IT() function to optimize interrupts enable
    - update HAL_DMA_PollForTransfer() function to optimize check on flags
    - update HAL_DMA_IRQHandler() function to optimize interrupt flag management
  - Fix in HAL_DMA_PollForTransfer() to:
    - set DMA error code in case of HAL_ERROR status
    - set HAL Unlock before DMA state update
  - HAL_DMA_Init(): Update to clear the DBM bit in the SxCR register before setting the new configuration
  - DMA_SetConfig(): add to clear the DBM bit in the SxCR register
- HAL FLASH update
  - update HAL_FLASH_Program_IT() function by removing the pending flag clear
  - update HAL_FLASH_IRQHandler() function to improve erase operation procedure
  - update FLASH_WaitForLastOperation() function by checking on end of operation flag
  - Add “HAL_” prefix in the defined values for the FLASH error code
  - Example: FLASH_ERROR_PGP renamed by HAL_FLASH_ERROR_PGP
  - Clear the Flash ErrorCode in the FLASH_WaitForLastOperation() function
  - Update FLASH_SetErrorCode() function to use “|=” operant to update the Flash ErrorCode parameter in the FLASH handle
  - IS_FLASH_ADDRESS(): Update the macro check using ‘<=’ condition instead of ‘<’
  - IS_OPTIONBYTE(): Update the macro check using ‘<=’ condition instead of ‘<’
  - Add “FLASH_” prefix in the defined values of FLASH Type Program parameter
  - Example: TYPEPROGRAM_BYTE renamed by FLASH_TYPEPROGRAM_BYTE
  - Add “FLASH_” prefix in the defined values of FLASH Type Erase parameter
  - Example: TYPEERASE_SECTORS renamed by FLASH_TYPEERASE_SECTORS
  - Add “FLASH_” prefix in the defined values of FLASH Voltage Range parameter
  - Example: VOLTAGE_RANGE_1 renamed by FLASH_VOLTAGE_RANGE_1
  - Add “OB_” prefix in the defined values of FLASH WRP State parameter
  - Example: WRPSTATE_ENABLE renamed by OB_WRPSTATE_ENABLE
  - __HAL_FLASH_INSTRUCTION_CACHE_RESET() macro: update to reset ICRST bit in the ACR register after setting it.
  - __HAL_FLASH_DATA_CACHE_RESET() macro: update to reset DCRST bit in the ACR register after setting it.
  - FLASH_OB_GetRDP() API update to return uint8_t instead of FlagStatus
  - __HAL_FLASH_GET_LATENCY() new macro add to get the flash latency
- HAL ETH update
  - Update HAL_ETH_GetReceivedFrame_IT() function to return HAL_ERROR if the received packet is not complete
  - Use HAL_Delay() instead of counting loop
  - __HAL_ETH_MAC_CLEAR_FLAG() macro is removed: the MACSR register is read only
  - Add the following macros used toWake up the device from STOP mode by Ethernet event :
    - __HAL_ETH_WAKEUP_EXTI_ENABLE_IT()
    - __HAL_ETH_WAKEUP_EXTI_DISABLE_IT()
    - __HAL_ETH_WAKEUP_EXTI_GET_FLAG()
    - __HAL_ETH_WAKEUP_EXTI_CLEAR_FLAG()
    - __HAL_ETH_WAKEUP_EXTI_ENABLE_RISING_EGDE_TRIGGER()
    - __HAL_ETH_WAKE_EXTI_ENABLE_FALLING_EGDE_TRIGGER()
    - __HAL_ETH_WAKE_EXTI_ENABLE_FALLINGRISING_TRIGGER()
  - Rename literals
    - ETH_PROMISCIOUSMODE_ENABLE by ETH_PROMISCUOUS_MODE_ENABLE
    - ETH_PROMISCIOUSMODE_DISABLE by ETH_PROMISCUOUS_MODE_DISABLE
  - Remove illegal space ETH_MAC_READCONTROLLER_FLUSHING macro
  - Update ETH_MAC_READCONTROLLER_XXX defined values (XXX can be IDLE, READING_DATA and READING_STATUS)
- HAL PWR update
  - HAL_PWR_ConfigPVD(): add clear of the EXTI trigger before new configuration
  - Fix in HAL_PWR_EnterSTANDBYMode() to not clear Wakeup flag (WUF), which need to be cleared at application level before to call this function
  - HAL_PWR_EnterSLEEPMode()
    - Remove disable and enable of SysTick Timer
    - Update to clear SLEEPDEEP bit of Cortex System Control Register (SCB->SCR) before entering in sleep mode
    - Update usage of __WFE() in low power entry function: if there is a pending event, calling __WFE() will not enter the CortexM3 core to sleep mode. The solution is to made the call below; the first __WFE() is always ignored and clears the event if one was already pending, the second is always applied
      - __SEV()
      - __WFE()
      - __WFE()
  - Add new macro for software event generation __HAL_PWR_PVD_EXTI_GENERATE_SWIT()
  - Remove the following defines form Generic driver and add them under extension driver because they are only used within extension functions.
  - CR_FPDS_BB: used within HAL_PWREx_EnableFlashPowerDown() function
  - CSR_BRE_BB: used within HAL_PWREx_EnableBkUpReg() function
  - Add new API to manage SLEEPONEXIT and SEVONPEND bits of SCR register
    - HAL_PWR_DisableSleepOnExit()
    - HAL_PWR_EnableSleepOnExit()
    - HAL_PWR_EnableSEVOnPend()
    - HAL_PWR_DisableSEVOnPend()
  - HAL_PWR_EnterSLEEPMode()
    - Update to clear the CORTEX SLEEPDEEP bit of SCR register before entering in sleep mode
  - Add new PVD configuration modes
    - PWR_PVD_MODE_NORMAL
    - PWR_PVD_MODE_EVENT_RISING
    - PWR_PVD_MODE_EVENT_FALLING
    - PWR_PVD_MODE_EVENT_RISING_FALLING
  - Add new macros to manage PVD Trigger
    - __HAL_PWR_PVD_EXTI_ENABLE_RISING_EDGE()
    - __HAL_PWR_PVD_EXTI_DISABLE_RISING_EDGE(
    - __HAL_PWR_PVD_EXTI_ENABLE_FALLING_EDGE()
    - __HAL_PWR_PVD_EXTI_DISABLE_FALLING_EDGE()
    - __HAL_PWR_PVD_EXTI_ENABLE_RISING_FALLING_EDGE()
    - __HAL_PWR_PVD_EXTI_DISABLE_RISING_FALLING_EDGE()
  - PVD macros:
    - Remove the EXTILINE parameter
    - Update to use prefix "__HAL_PWR_PVD_" instead of prefix "__HAL_PVD"
  - Rename HAL_PWR_PVDConfig() function by HAL_PWR_ConfigPVD()
- HAL GPIO update
  - Rename GPIO_SPEED_LOW define to GPIO_SPEED_FREQ_LOW
  - Rename GPIO_SPEED_MEDIUM define to GPIO_SPEED_FREQ_MEDIUM
  - Rename GPIO_SPEED_FAST define to GPIO_SPEED_FREQ_HIGH
  - Rename GPIO_SPEED_HIGH define to GPIO_SPEED_FREQ_VERY_HIGH
  - Add a new macro __HAL_GPIO_EXTI_GENERATE_SWIT() to manage the generation of software interrupton selected EXTI line
  - HAL_GPIO_Init(): use temporary variable when modifying the registers, to avoid unexpected transition in the GPIO pin configuration
  - Remove IS_GET_GPIO_PIN macro
  - Add a new function HAL_GPIO_LockPin()
  - Update the following HAL GPIO macros description: rename EXTI_Linex by GPIO_PIN_x
    - __HAL_GPIO_EXTI_CLEAR_IT()
    - __HAL_GPIO_EXTI_GET_IT()
    - __HAL_GPIO_EXTI_CLEAR_FLAG()
    - __HAL_GPIO_EXTI_GET_FLAG()
  - HAL_GPIO_Init()/HAL_GPIO_DeInit(): add a call to the CMSIS assert macro to check GPIO instance: IS_GPIO_ALL_INSTANCE()
  - Rename __HAL_GET_GPIO_SOURCE() by GPIO_GET_INDEX() and move this later to file stm32f2xx_hal_gpio_ex.h
  - HAL_GPIO_DeInit(): Update to check if GPIO Pin x is already used in EXTI mode on another GPIO Port before De-Initialize the EXTI registers
- HAL HASH update
  - HAL_HASH_MD5_Start_IT(): fix input address management issue
  - HAL_HASH_MODE_Start_IT() (MODE stands for MD5 and SHA1) updates:
    - Fix processing fail for small input buffers
    - Update to unlock the process and call return HAL_OK at the end of HASH processing to avoid incorrectly repeating software
    - Update to properly manage the HashITCounter
    - Update to call the HAL_HASH_InCpltCallback() at the end of the complete buffer instead of every each 512 bits
  - __HAL_HASH_GET_FLAG() update to check the right register when the DINNE flag is selected
  - HAL_HASH_SHA1_Accumulate() updates:
    - Add a call to the new IS_HASH_SHA1_BUFFER_SIZE() macro to check the size parameter.
    - Add the following note in API description
      - - @note Input buffer size in bytes must be a multiple of 4 otherwise the digest computation is corrupted.
- HAL RCC update
  - HAL_RCCEx_PeriphCLKConfig() updates:
    - Update the LSE check condition after backup domain reset: update to check LSE ready flag when LSE oscillator is already enabled instead of check on LSE oscillator only when LSE is used as RTC clock source
  - In HAL_RCC_ClockConfig()function: update the AHB clock divider before clock switch to new source
  - Allow to calibrate the HSI when it is used as system clock source
  - Reorganize the RCC macros to make them more clear
  - Rename the following Macros
    - __PPP_CLK_ENABLE() by __HAL_RCC_PPP_CLK_ENABLE()
    - __PPP_CLK_DISABLE() by __HAL_RCC_PPP_CLK_DISABLE()
    - __PPP_FORCE_RESET() by __HAL_RCC_PPP_FORCE_RESET()
    - __PPP_RELEASE_RESET() by __HAL_RCC_PPP_RELEASE_RESET()
    - __PPP_CLK_SLEEP_ENABLE() by __HAL_RCC_PPP_CLK_SLEEP_ENABLE()
    - __PPP_CLK_SLEEP_DISABLE() by __HAL_RCC_PPP_CLK_SLEEP_DISABLE()
  - Add description of RCC known Limitations
  - HAL_RCC_OscConfig() fix issues:
    - Remove the disable of HSE oscillator when HSE_BYPASS is used as system clock source or as PPL clock source
    - Add a check on HSERDY flag when HSE_BYPASS is selected as new state for HSE oscillator.
  - Rename __HAL_RCC_I2SCLK() by __HAL_RCC_I2S_Config()
  - __HAL_RCC_PPP_CLK_ENABLE(): Implement workaround to cover RCC limitation regarding peripheral enable delay
  - HAL_RCC_OscConfig() fix issues:
    - Add a check on LSERDY flag when LSE_BYPASS is selected as new state for LSE oscillator.
  - __HAL_RCC_HSE_CONFIG() macro: add the comment below:
    - - @note Transition HSE Bypass to HSE On and HSE On to HSE Bypass are not supported by this macro.
    - - User should request a transition to HSE Off first and then HSE On or HSE Bypass.
  - __HAL_RCC_LSE_CONFIG() macro: add the comment below:
    - - @note Transition LSE Bypass to LSE On and LSE On to LSE Bypass are not supported by this macro.
    - - User should request a transition to LSE Off first and then LSE On or LSE Bypass.
  - Add the following new macros for PLL source and PLLM selection :
    - __HAL_RCC_PLL_PLLSOURCE_CONFIG()
    - __HAL_RCC_PLL_PLLM_CONFIG()
  - Add __HAL_RCC_SYSCLK_CONFIG() new macro to configure the system clock source (SYSCLK)
  - __HAL_RCC_GET_SYSCLK_SOURCE() updates:
  - Add new RCC Literals:
    - RCC_SYSCLKSOURCE_STATUS_HSI
    - RCC_SYSCLKSOURCE_STATUS_HSE
    - RCC_SYSCLKSOURCE_STATUS_PLLCLK
  - Update macro description to refer to the literals above
- HAL I2S update
  - HAL_I2S_Init(): add check on I2S instance using CMSIS macro IS_I2S_ALL_INSTANCE()
  - HAL_I2S_IRQHandler() update for compliancy w/ C++
  - Add use of tmpreg variable in __HAL_I2S_CLEAR_OVRFLAG() and __HAL_I2S_CLEAR_UDRFLAG() macro for compliancy with C++
  - HAL_I2S_GetError(): update to return uint32_t instead of HAL_I2S_ErrorTypeDef enumeration
  - HAL_I2S_Transmit() API update to check on busy flag only for I2S slave mode
- HAL I2C update
  - I2C Polling/IT/DMA processes: move the wait loop on busy flag at the top of the processes, to ensure that software not perform any write access to I2C_CR1 register before hardware clearing STOP bit and to avoid also the waiting loop on BUSY flag under I2C/DMA ISR.
  - Update busy flag Timeout value
  - I2C Master Receive Processes update to disable ACK before generate the STOP
  - Update to clear the POS bit in the CR1 register at the begging of all the HAL I2C processes
  - Add use of tmpreg variable in __HAL_I2C_CLEAR_ADDRFLAG() and __HAL_I2C_CLEAR_STOPFLAG() macro for compliancy with C++
- HAL IrDA update
  - Add specific macros to manage the flags cleared only by a software sequence ◾__HAL_IRDA_CLEAR_PEFLAG()
    - __HAL_ IRDA _CLEAR_FEFLAG()
    - __HAL_ IRDA _CLEAR_NEFLAG()
    - __HAL_ IRDA _CLEAR_OREFLAG()
    - __HAL_ IRDA _CLEAR_IDLEFLAG()
  - Add several enhancements without affecting the driver functionalities
    - Remove the check on RXNE set after reading the Data in the DR register
    - Update HAL_IRDA_Transmit_IT() to enable IRDA_IT_TXE instead of IRDA_IT_TC
  - Add the following APIs used within DMA process ◾HAL_StatusTypeDef HAL_IRDA_DMAPause(IRDA_HandleTypeDef *hirda);
    - HAL_StatusTypeDef HAL_IRDA_DMAResume(IRDA_HandleTypeDef *hirda);
    - HAL_StatusTypeDef HAL_IRDA_DMAStop(IRDA_HandleTypeDef *hirda);
    - void HAL_IRDA_TxHalfCpltCallback(IRDA_HandleTypeDef *hirda);
    - void HAL_IRDA_RxHalfCpltCallback(IRDA_HandleTypeDef *hirda);
  - DMA transmit process; the code has been updated to avoid waiting on TC flag under DMA ISR, IrDA TC interrupt is used instead. Below the update to be done on user application:
    - Configure and enable the USART IRQ in HAL_IRDA_MspInit() function
    - In stm32f2xx_it.c file, UASRTx_IRQHandler() function: add a call to HAL_IRDA_IRQHandler() function
  - IT transmit process; the code has been updated to avoid waiting on TC flag under IRDA ISR, IrDA TC interrupt is used instead. No impact on user application
  - Rename Macros: add prefix "__HAL"
    - __IRDA_ENABLE() by __HAL_IRDA_ENABLE()
    - __IRDA_DISABLE() by __HAL_IRDA_DISABLE()
  - Add new user macros to manage the sample method feature
    - __HAL_IRDA_ONE_BIT_SAMPLE_ENABLE()
    - __HAL_IRDA_ONE_BIT_SAMPLE_DISABLE()
  - HAL_IRDA_Transmit_IT(): update to remove the enable of the parity error interrupt
  - Add use of tmpreg variable in __HAL_IRDA_CLEAR_PEFLAG() macro for compliancy with C++
  - HAL_IRDA_Transmit_DMA() update to follow the right procedure “Transmission using DMA” in the reference manual
    - Add clear the TC flag in the SR register before enabling the DMA transmit request
- HAL SPI update
  - SPI interface is used in synchronous polling mode: at high clock rates like SPI prescaler 2 and 4, calling
  - AL_SPI_TransmitReceive() returns with error HAL_TIMEOUT
  - HAL_SPI_TransmitReceive_DMA() does not clean up the TX DMA, so any subsequent SPI calls return the DMA error
  - HAL_SPI_Transmit_DMA() is failing when data size is equal to 1 byte
  - Add the following APIs used within the DMA process
    - HAL_StatusTypeDef HAL_SPI_DMAPause(SPI_HandleTypeDef *hspi);
    - HAL_StatusTypeDef HAL_SPI_DMAResume(SPI_HandleTypeDef *hspi);
    - HAL_StatusTypeDef HAL_SPI_DMAStop(SPI_HandleTypeDef *hspi);
    - void HAL_SPI_TxHalfCpltCallback(SPI_HandleTypeDef *hspi);
    - void HAL_SPI_RxHalfCpltCallback(SPI_HandleTypeDef *hspi);
    - void HAL_SPI_TxRxHalfCpltCallback(SPI_HandleTypeDef *hspi);
  - HAL_SPI_TransmitReceive_DMA() update to remove the DMA Tx Error Callback initialization when SPI RxOnly mode is selected
  - Add use of UNUSED(tmpreg) in __HAL_SPI_CLEAR_MODFFLAG(), __HAL_SPI_CLEAR_OVRFLAG(), __HAL_SPI_CLEAR_FREFLAG() to fix “Unused variable” warning with TrueSTUDIO.
  - Rename Literals: remove “D” from “DISABLED” and “ENABLED”
    - SPI_TIMODE_DISABLED by SPI_TIMODE_DISABLE
    - SPI_TIMODE_ENABLED by SPI_TIMODE_ENABLE
    - SPI_CRCCALCULATION_DISABLED by SPI_CRCCALCULATION_DISABLE
    - SPI_CRCCALCULATION_ENABLED by SPI_CRCCALCULATION_ENABLE
  - Add use of tmpreg variable in __HAL_SPI_CLEAR_MODFFLAG(), __HAL_SPI_CLEAR_FREFLAG() and __HAL_SPI_CLEAR_OVRFLAG() macros for compliancy with C++
  - HAL_SPI_Transmit_DMA()/HAL_SPI_Receive_DMA()/HAL_SPI_TransmitReceive_DMA() update to unlock the process before enabling the SPI peripheral
  - HAL_SPI_Transmit_DMA() update to manage correctly the DMA TX stream in SPI Full duplex mode
  - Section SPI_Exported_Functions_Group2 update to remove duplication in *.chm UM
  - Fix the wrong definition of HAL_SPI_ERROR_FLAG literal
- HAL CRC update
  - These macros are added to read/write the CRC IDR register: __HAL_CRC_SET_IDR() and __HAL_CRC_GET_IDR()
- __HAL_CRC_SET_IDR() macro implementation change to use WRITE_REG() instead of MODIFY_REG()
- HAL LL SDMMC update
  - Use of CMSIS constants instead of magic values
  - Miscellaneous update in functions internal coding
  - IS_SDIO_ALL_INSTANCE() macro moved to CMSIS files
- HAL NAND update
  - Fix issue of macros returning wrong address for NAND blocks
  - Fix issue for read/write NAND page/spare area
  - Rename NAND Address structure to NAND_AddressTypeDef instead of NAND_AddressTypedef
  - Update the used algorithm of these functions
    - HAL_NAND_Read_Page()
    - HAL_NAND_Write_Page()
    - HAL_NAND_Read_SpareArea()
    - HAL_NAND_Write_SpareArea()
  - HAL_NAND_Write_Page(): move initialization of tickstart before while loop
  - HAL_NAND_Erase_Block(): add whait until NAND status is ready before exiting this function
- HAL NOR update
  - Add the NOR addressbank macro used within the API
  - Update NOR APIimplementation to avoid the use of NOR address bank hard coded
  - NOR Status literals renamed
    - NOR_SUCCESS by HAL_NOR_STATUS_SUCCESS
    - NOR_ONGOING by HAL_NOR_STATUS_ONGOING
    - NOR_ERROR by HAL_NOR_STATUS_ERROR
    - NOR_TIMEOUT by HAL_NOR_STATUS_TIMEOUT
  - HAL_NOR_GetStatus() update to fix Timeout issue and exit from waiting loop when timeout occurred
- HAL PCCARD update
- Rename PCCARD Address structure to HAL_PCCARD_StatusTypeDef instead of CF_StatusTypedef
- PCCARD Status literals renamed
  - CF_SUCCESS by HAL_PCCARD_STATUS_SUCCESS
  - CF_ONGOING by HAL_PCCARD_STATUS_ONGOING
  - CF_ERROR by HAL_PCCARD_STATUS_ERROR
  - CF_TIMEOUT by HAL_PCCARD_STATUS_TIMEOUT
- Update “CF” by “PCCARD” in functions, literals and macros
- HAL HCD update
  - HCD_StateTypeDef structure members renamed
  - These macro are renamed
    - __HAL_GET_FLAG(HANDLE, INTERRUPT) by __HAL_HCD_GET_FLAG(HANDLE, INTERRUPT)
    - __HAL_IS_INVALID_INTERRUPT(HANDLE) by __HAL_HCD_IS_INVALID_INTERRUPT(HANDLE)
  - Update to use local variable in USB Host channel re-activation
- HAL PCD update
  - HAL_PCD_SetTxFiFo() and HAL_PCD_SetRxFiFo() renamed into HAL_PCDEx_SetTxFiFo() and HAL_PCDEx_SetRxFiFo() and moved to the extension files stm32f2xx_hal_pcd_ex.h/.c
  - PCD_StateTypeDef structure members renamed
  - Fix incorrect masking of TxFIFOEmpty
  - stm32f2xx_ll_usb.c: fix issue in HS mode
  - New macros added
    - __HAL_PCD_IS_PHY_SUSPENDED()
    - __HAL_USB_HS_EXTI_GENERATE_SWIT()
    - __HAL_USB_FS_EXTI_GENERATE_SWIT()
  - These macro are renamed
    - __HAL_GET_FLAG(HANDLE, INTERRUPT) by __HAL_PCD_GET_FLAG(HANDLE, INTERRUPT)
    - __HAL_CLEAR_FLAG(HANDLE, INTERRUPT) by __HAL_PCD_CLEAR_FLAG(HANDLE, INTERRUPT)
    - __HAL_IS_INVALID_INTERRUPT(HANDLE) by __HAL_PCD_IS_INVALID_INTERRUPT(HANDLE)
    - __HAL_PCD_UNGATE_CLOCK(HANDLE) by __HAL_PCD_UNGATE_PHYCLOCK(HANDLE)
    - __HAL_PCD_GATE_CLOCK(HANDLE) by __HAL_PCD_GATE_PHYCLOCK(HANDLE)
  - Rename functions
    - HAL_PCD_ActiveRemoteWakeup() by HAL_PCD_ActivateRemoteWakeup()
    - HAL_PCD_DeActiveRemoteWakeup() by HAL_PCD_DeActivateRemoteWakeup()
  - Rename literals
    - USB_FS_EXTI_TRIGGER_RISING_EDGE by USB_OTG_FS_WAKEUP_EXTI_RISING_EDGE
    - USB_FS_EXTI_TRIGGER_FALLING_EDGE by USB_OTG_FS_WAKEUP_EXTI_FALLING_EDGE
    - USB_FS_EXTI_TRIGGER_BOTH_EDGE() by USB_OTG_FS_WAKEUP_EXTI_RISING_FALLING_EDGE
    - USB_HS_EXTI_TRIGGER_RISING_EDGE by USB_OTG_HS_WAKEUP_EXTI_RISING_EDGE
    - USB_HS_EXTI_TRIGGER_FALLING_EDGE by USB_OTG_HS_WAKEUP_EXTI_FALLING_EDGE
    - USB_HS_EXTI_TRIGGER_BOTH_EDGE by USB_OTG_HS_WAKEUP_EXTI_RISING_FALLING_EDGE
    - USB_HS_EXTI_LINE_WAKEUP by USB_OTG_HS_WAKEUP_EXTI_LINE
    - USB_FS_EXTI_LINE_WAKEUP by USB_OTG_FS_WAKEUP_EXTI_LINE
  - Rename USB EXTI macros (FS, HS referenced as SUBBLOCK here below)
    - __HAL_USB_SUBBLOCK_EXTI_ENABLE_IT() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_ENABLE_IT()
    - __HAL_USB_SUBBLOCK_EXTI_DISABLE_IT() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_DISABLE_IT()
    - __HAL_USB_SUBBLOCK_EXTI_GET_FLAG() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_GET_FLAG()
    - __HAL_USB_SUBBLOCK_EXTI_CLEAR_FLAG() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_CLEAR_FLAG()
    - __HAL_USB_SUBBLOCK_EXTI_SET_RISING_EGDE_TRIGGER() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_ENABLE_RISING_EDGE()
    - __HAL_USB_SUBBLOCK_EXTI_SET_FALLING_EGDE_TRIGGER() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_ENABLE_FALLING_EDGE()
    - __HAL_USB_SUBBLOCK_EXTI_SET_FALLINGRISING_TRIGGER() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_ENABLE_RISING_FALLING_EDGE()
    - __HAL_USB_SUBBLOCK_EXTI_GENERATE_SWIT() by __HAL_USB_OTG_SUBBLOCK_WAKEUP_EXTI_GENERATE_SWIT()
  - HAL_PCD_IRQHandler API: fix the bad Configuration of Turnaround Time
- HAL RNG update
  - Add new functions
    - HAL_RNG_GenerateRandomNumber(): to generate a 32-bits random number, return random value in argument and return HAL status.
    - HAL_RNG_GenerateRandomNumber_IT(): to start generation of the 32-bits random number, user should call the HAL_RNG_ReadLastRandomNumber() function under the HAL_RNG_ReadyCallback() to get the generated random value.
    - HAL_RNG_ReadLastRandomNumber(): to return the last random value stored in the RNG handle
  - HAL_RNG_GetRandomNumber(): return value update (obsolete), replaced by HAL_RNG_GenerateRandomNumber()
  - HAL_RNG_GetRandomNumber_IT(): wrong implementation (obsolete), replaced by HAL_RNG_GenerateRandomNumber_IT()
  - __HAL_RNG_CLEAR_FLAG() macro (obsolete), replaced by new __HAL_RNG_CLEAR_IT() macro
  - Add new define for RNG ready interrupt: RNG_IT_DRDY
- HAL RTC update
  - Update HAL_RTCEx_SetWakeUpTimer() and HAL_RTCEx_SetWakeUpTimer_IT() functions to properly check on the WUTWF flag
  - HAL_RTC_GetTime() and HAL_RTC_GetDate(): add the comment below
  - - @note You must call HAL_RTC_GetDate() after HAL_RTC_GetTime() to unlock the values
  - - in the higher-order calendar shadow registers to ensure consistency between the time and date values.
  - - Reading RTC current time locks the values in calendar shadow registers until Current date is read.
  - Rename literals: add prefix "__HAL"
    - FORMAT_BIN by RTC_FORMAT_BIN
    - FORMAT_BCD by RTC_FORMAT_BCD
  - Rename macros (ALARM, WAKEUPTIMER and TIMESTAMP referenced as SUBBLOCK here below)
    - __HAL_RTC_EXTI_ENABLE_IT() by __HAL_RTC_SUBBLOCK_EXTI_ENABLE_IT()
    - __HAL_RTC_EXTI_DISABLE_IT() by __HAL_RTC_SUBBLOCK_EXTI_DISABLE_IT()
    - __HAL_RTC_EXTI_CLEAR_FLAG() by __HAL_RTC_SUBBLOCK_EXTI_CLEAR_FLAG()
    - __HAL_RTC_EXTI_GENERATE_SWIT() by __HAL_RTC_SUBBLOCK_EXTI_GENERATE_SWIT()
  - Add new macros (ALARM, WAKEUPTIMER and TAMPER_TIMESTAMP referenced as SUBBLOCK here below)
    - __HAL_RTC_SUBBLOCK_GET_IT_SOURCE()
    - __HAL_RTC_SUBBLOCK_EXTI_ENABLE_EVENT()
    - __HAL_RTC_SUBBLOCK_EXTI_DISABLE_EVENT()
    - __HAL_RTC_SUBBLOCK_EXTI_ENABLE_FALLING_EDGE()
    - __HAL_RTC_SUBBLOCK_EXTI_DISABLE_FALLING_EDGE()
    - __HAL_RTC_SUBBLOCK_EXTI_ENABLE_RISING_EDGE()
    - __HAL_RTC_SUBBLOCK_EXTI_DISABLE_RISING_EDGE()
    - __HAL_RTC_SUBBLOCK_EXTI_ENABLE_RISING_FALLING_EDGE()
    - __HAL_RTC_SUBBLOCK_EXTI_DISABLE_RISING_FALLING_EDGE()
    - __HAL_RTC_SUBBLOCK_EXTI_GET_FLAG()
  - Update to use CMSIS mask definition instead of hardcoded values (EXTI_IMR_IM17, EXTI_IMR_IM19..)
  - __HAL_RTC_TAMPER_TIMESTAMP_EXTI_GET_FLAG() macro: fix implementation issue
  - __HAL_RTC_ALARM_GET_IT(), __HAL_RTC_ALARM_CLEAR_FLAG(), __HAL_RTC_WAKEUPTIMER_CLEAR_FLAG(), __HAL_RTC_TIMESTAMP_CLEAR_FLAG() and __HAL_RTC_TAMPER_CLEAR_FLAG() macros implementation changed: remove unused cast
  - IS_RTC_TAMPER() macro: update to use literal instead of hardcoded value
  - Update to define hardware independent literals names:
    - Rename RTC_TAMPERPIN_PC13 by RTC_TAMPERPIN_DEFAULT
    - Rename RTC_TAMPERPIN_PA0 by RTC_TAMPERPIN_POS1
    - Rename RTC_TAMPERPIN_PI8 by RTC_TAMPERPIN_POS1
    - Rename RTC_TIMESTAMPPIN_PC13 by RTC_TIMESTAMPPIN_DEFAULT
    - Rename RTC_TIMESTAMPPIN_PA0 by RTC_TIMESTAMPPIN_POS1
    - Rename RTC_TIMESTAMPPIN_PI8 by RTC_TIMESTAMPPIN_POS1
- HAL SD update
  - Rename SD_CMD_SD_APP_STAUS by SD_CMD_SD_APP_STATUS
  - SD_PowerON() updated to add 1ms required power up waiting time before starting the SD initialization sequence
  - SD_DMA_RxCplt()/SD_DMA_TxCplt(): add a call to HAL_DMA_Abort()
  - HAL_SD_ReadBlocks() update to set the defined DATA_BLOCK_SIZE as SDIO DataBlockSize parameter
  - HAL_SD_ReadBlocks_DMA()/HAL_SD_WriteBlocks_DMA() update to call the HAL_DMA_Start_IT() function withDMA Datalength set to BlockSize/4 as the DMA is configured in word
- HAL SMARTCARD update
  - Add specific macros to manage the flags cleared only by a software sequence ◾__HAL_SMARTCARD_CLEAR_PEFLAG()
    - __HAL_SMARTCARD_CLEAR_FEFLAG()
    - __HAL_SMARTCARD_CLEAR_NEFLAG()
    - __HAL_SMARTCARD_CLEAR_OREFLAG()
    - __HAL_SMARTCARD_CLEAR_IDLEFLAG()
  - Add several enhancements without affecting the driver functionalities
    - Add a new state HAL_SMARTCARD_STATE_BUSY_TX_RX and all processes has been updated accordingly
    - Update HAL_SMARTCARD_Transmit_IT() to enable SMARTCARD_IT_TXE instead of SMARTCARD_IT_TC
  - DMA transmit process; the code has been updated to avoid waiting on TC flag under DMA ISR, SMARTCARD TC interrupt is used instead. Below the update to be done on user application:
    - Configure and enable the USART IRQ in HAL_SAMRTCARD_MspInit() function
    - In stm32f2xx_it.c file, UASRTx_IRQHandler() function: add a call to HAL_SMARTCARD_IRQHandler() function
  - IT transmit process; the code has been updated to avoid waiting on TC flag under SMARTCARD ISR, SMARTCARD TC interrupt is used instead. No impact on user application
  - Rename macros: add prefix "__HAL"
    - __SMARTCARD_ENABLE() by __HAL_SMARTCARD_ENABLE()
    - __SMARTCARD_DISABLE() by __HAL_SMARTCARD_DISABLE()
    - __SMARTCARD_ENABLE_IT() by __HAL_SMARTCARD_ENABLE_IT()
    - __SMARTCARD_DISABLE_IT() by __HAL_SMARTCARD_DISABLE_IT()
    - __SMARTCARD_DMA_REQUEST_ENABLE() by __HAL_SMARTCARD_DMA_REQUEST_ENABLE()
    - __SMARTCARD_DMA_REQUEST_DISABLE() by __HAL_SMARTCARD_DMA_REQUEST_DISABLE()
  - Rename literals: remove “D” from “DISABLED” and “ENABLED”
    - SMARTCARD_NACK_ENABLED by SMARTCARD_NACK_ENABLE
    - SMARTCARD_NACK_DISABLED by SMARTCARD_NACK_DISABLE
  - Add new user macros to manage the sample method feature
    - __HAL_SMARTCARD_ONE_BIT_SAMPLE_ENABLE()
    - __HAL_SMARTCARD_ONE_BIT_SAMPLE_DISABLE()
  - Add use of tmpreg variable in __HAL_SMARTCARD_CLEAR_PEFLAG() macro for compliancy with C++
  - HAL_SMARTCARD_Transmit_DMA() update to follow the right procedure “Transmission using DMA” in the reference manual
    - Add clear the TC flag in the SR register before enabling the DMA transmit request
    - HAL_SMARTCARD_Transmit_IT() update to force the disable for the ERR interrupt to avoid the OVR interrupt
    - HAL_SMARTCARD_IRQHandler() update check condition for transmission end
    - Clean up: remove the following literals that aren’t used in smartcard mode
      - SMARTCARD_PARITY_NONE
      - SMARTCARD_WORDLENGTH_8B
      - SMARTCARD_STOPBITS_1
      - SMARTCADR_STOPBITS_2
- HAL TIM update
  - HAL_TIM_IRQHandler(): update to check the input capture channel 3 and 4 in CCMR2 instead of CCMR1
  - __HAL_TIM_SET_PRESCALER() updated to use ‘=’ instead of ‘|=’
  - Add thefollowing macro in TIM HAL driver
  - __HAL_TIM_GET_COMPARE()
  - __HAL_TIM_GET_COUNTER()
  - __HAL_TIM_GET_AUTORELOAD()
  - __HAL_TIM_GET_CLOCKDIVISION()
  - __HAL_TIM_GET_ICPRESCALER()
  - Add TIM_CHANNEL_ALL as possible value for all Encoder Start/Stop APIs Description
  - HAL_TIM_OC_ConfigChannel() remove call to IS_TIM_FAST_STATE() assert macro
  - HAL_TIM_PWM_ConfigChannel() add a call to IS_TIM_FAST_STATE() assert macro to check the OCFastMode parameter
  - TIM_DMADelayPulseCplt() Update to set the TIM Channel before to call HAL_TIM_PWM_PulseFinishedCallback()
  - TIM_DMACaptureCplt() update to set the TIM Channel before to call HAL_TIM_IC_CaptureCallback()
  - HAL_TIM_IC_ConfigChannel() update to fix Timer CCMR1 register corruption when setting ICFilter parameter
  - HAL_TIM_DMABurst_WriteStop()/HAL_TIM_DMABurst_ReadStop() update to abort the DMA transfer for the specific TIM channel
  - Add new function for TIM Slave configuration in IT mode: HAL_TIM_SlaveConfigSynchronization_IT()
  - HAL_TIMEx_ConfigBreakDeadTime() add an assert check on Break & DeadTime parameters values
  - HAL_TIMEx_OCN_Start_IT() add the enable of Break Interrupt for all output modes
  - Add new macros to ENABLE/DISABLE URS bit in TIM CR1 register:
    - __HAL_TIM_URS_ENABLE()
    - __HAL_TIM_URS_DISABLE()
  - Add new macro for TIM Edge modification: __HAL_TIM_SET_CAPTUREPOLARITY()
- HAL UART update
  - Add new macros to control CTS and RTS
  - Add specific macros to manage the flags cleared only by a software sequence ◾__HAL_UART_CLEAR_PEFLAG()
    - __HAL_UART_CLEAR_FEFLAG()
    - __HAL_UART_CLEAR_NEFLAG()
    - __HAL_UART_CLEAR_OREFLAG()
    - __HAL_UART_CLEAR_IDLEFLAG()
  - Remove the check on RXNE set after reading the Data in the DR register
  - Add IS_UART_LIN_WORD_LENGTH() and IS_UART_LIN_OVERSAMPLING() macros: to check respectively WordLength and OverSampling parameters in LIN mode
  - DMA transmit process; the code has been updated to avoid waiting on TC flag under DMA ISR, UART TC interrupt is used instead. Below the update to be done on user application:
    - Configure and enable the USART IRQ in HAL_UART_MspInit() function
    - In stm32f2xx_it.c file, USARTx_IRQHandler() function: add a call to HAL_UART_IRQHandler() function
  - IT transmit process; the code has been updated to avoid waiting on TC flag under UART ISR, UART TC interrupt is used instead. No impact on user application
  - Rename macros:
    - __HAL_UART_ONEBIT_ENABLE() by __HAL_UART_ONE_BIT_SAMPLE_ENABLE()
    - __HAL_UART_ONEBIT_DISABLE() by __HAL_UART_ONE_BIT_SAMPLE_DISABLE()
  - Rename literals:
    - UART_WAKEUPMETHODE_IDLELINE by UART_WAKEUPMETHOD_IDLELINE
    - UART_WAKEUPMETHODE_ADDRESSMARK by UART_WAKEUPMETHOD_ADDRESSMARK
  - Add use of tmpreg variable in __HAL_UART_CLEAR_PEFLAG() macro for compliancy with C++
  - HAL_UART_Transmit_DMA() update to follow the right procedure “Transmission using DMA” in the reference manual
    - Add clear the TC flag in the SR register before enabling the DMA transmit request
- HAL USART update
  - Add specific macros to manage the flags cleared only by a software sequence ◾__HAL_USART_CLEAR_PEFLAG()
    - __HAL_USART_CLEAR_FEFLAG()
    - __HAL_USART_CLEAR_NEFLAG()
    - __HAL_USART_CLEAR_OREFLAG()
    - __HAL_USART_CLEAR_IDLEFLAG()
  - Update HAL_USART_Transmit_IT() to enable USART_IT_TXE instead of USART_IT_TC
  - DMA transmit process; the code has been updated to avoid waiting on TC flag under DMA ISR, USART TC interrupt is used instead. Below the update to be done on user application:
    - Configure and enable the USART IRQ in HAL_USART_MspInit() function
    - In stm32f2xx_it.c file, USARTx_IRQHandler() function: add a call to HAL_USART_IRQHandler() function
  - IT transmit process; the code has been updated to avoid waiting on TC flag under USART ISR, USART TC interrupt is used instead. No impact on user application
  - HAL_USART_Init() update to enable the USART oversampling by 8 by default in order to reach max USART frequencies
  - USART_DMAReceiveCplt() update to set the new USART state after checking on the old state
  - HAL_USART_Transmit_DMA()/HAL_USART_TransmitReceive_DMA() update to follow the right procedure “Transmission using DMA” in the reference manual
    - Add clear the TC flag in the SR register before enabling the DMA transmit request
  - Rename macros:
    - __USART_ENABLE() by __HAL_USART_ENABLE()
    - __USART_DISABLE() by __HAL_USART_DISABLE()
    - __USART_ENABLE_IT() by __HAL_USART_ENABLE_IT()
    - __USART_DISABLE_IT() by __HAL_USART_DISABLE_IT()
  - Rename literals: remove “D” from “DISABLED” and “ENABLED”
    - USART_CLOCK_DISABLED by USART_CLOCK_DISABLE
    - USART_CLOCK_ENABLED by USART_CLOCK_ENABLE
    - USARTNACK_ENABLED by USART_NACK_ENABLE
    - USARTNACK_DISABLED by USART_NACK_DISABLE
  - Add new user macros to manage the sample method feature
    - __HAL_USART_ONE_BIT_SAMPLE_ENABLE()
    - __HAL_USART_ONE_BIT_SAMPLE_DISABLE()
  - Add use of tmpreg variable in __HAL_USART_CLEAR_PEFLAG() macro for compliancy with C++
  - HAL_USART_Init() fix USART baud rate configuration issue: USART baud rate is twice Higher than expected
- HAL WWDG update
  - Update macro parameters to use underscore: XXX
  - Use of CMSIS constants instead of magic values
  - Use MODIFY_REG macro in HAL_WWDG_Init()
  - Add IS_WWDG_ALL_INSTANCE in HAL_WWDG_Init() and HAL_WWDG_DeInit()
  - Add new parameter in __HAL_WWDG_ENABLE_IT() macro
  - Add new macros to manage WWDG IT & correction:
    - __HAL_WWDG_DISABLE()
    - __HAL_WWDG_DISABLE_IT()
    - __HAL_WWDG_GET_IT()
    - __HAL_WWDG_GET_IT_SOURCE()
- HAL IWDG update
  - Use WRITE_REG instead of SET_BIT for all IWDG macros
  - __HAL_IWDG_CLEAR_FLAG removed: no IWDG flag cleared by access to SR register
  - Use MODIFY_REG macro in HAL_IWDG_Init()
  - Add IS_IWDG_ALL_INSTANCE in HAL_IWDG_Init()
  - Rename the defined IWDG keys:
    - KR_KEY_RELOAD by IWDG_KEY_RELOAD
    - KR_KEY_ENABLE by IWDG_KEY_ENABLE
    - KR_KEY_EWA by IWDG_KEY_WRITE_ACCESS_ENABLE
    - KR_KEY_DWA by IWDG_KEY_WRITE_ACCESS_DISABLE
  - Add new macro: __HAL_IWDG_RESET_HANDLE_STATE()
  - Update IWDG_ENABLE_WRITE_ACCESS() and IWDG_DISABLE_WRITE_ACCESS() as private macro
- HAL LL FSMC update
  - Add WriteFifo and PageSize fields in the FSMC_NORSRAM_InitTypeDef structure
  - Update FSMC_NORSRAM_Init(), FSMC_NORSRAM_DeInit() and FSMC_NORSRAM_Extended_Timing_Init() functions
- HAL LL USB update
  - Update USB_HostInit() and USB_DevInit() functions to support the VBUS Sensing B activation
  - USB_FlushTxFifo API: update to flush all Tx FIFO
  - Update to use local variable in USB Host channel re-activation

V1.0.1 / 25-March-2014

## Main Changes

- Patch release : moved macros related to RNG from hal_rcc_ex.h to hal_rcc.h as RNG is present in all versions of the STM32F2

V1.0.0 / 07-March-2014

## Main Changes

- First official release